package org.xtext.example.mydsl.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.xtext.example.mydsl.services.DslBGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalDslBParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'.'", "'package'", "'{'", "'}'", "'import'", "'.*'", "'client'", "'host'"
    };
    public static final int RULE_ID=4;
    public static final int RULE_WS=9;
    public static final int RULE_STRING=6;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__15=15;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int RULE_INT=5;
    public static final int T__18=18;
    public static final int T__11=11;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__12=12;
    public static final int T__13=13;
    public static final int T__14=14;
    public static final int EOF=-1;

    // delegates
    // delegators


        public InternalDslBParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalDslBParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalDslBParser.tokenNames; }
    public String getGrammarFileName() { return "InternalDslB.g"; }


    	private DslBGrammarAccess grammarAccess;

    	public void setGrammarAccess(DslBGrammarAccess grammarAccess) {
    		this.grammarAccess = grammarAccess;
    	}

    	@Override
    	protected Grammar getGrammar() {
    		return grammarAccess.getGrammar();
    	}

    	@Override
    	protected String getValueForTokenName(String tokenName) {
    		return tokenName;
    	}



    // $ANTLR start "entryRuleModel"
    // InternalDslB.g:53:1: entryRuleModel : ruleModel EOF ;
    public final void entryRuleModel() throws RecognitionException {
        try {
            // InternalDslB.g:54:1: ( ruleModel EOF )
            // InternalDslB.g:55:1: ruleModel EOF
            {
             before(grammarAccess.getModelRule()); 
            pushFollow(FOLLOW_1);
            ruleModel();

            state._fsp--;

             after(grammarAccess.getModelRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleModel"


    // $ANTLR start "ruleModel"
    // InternalDslB.g:62:1: ruleModel : ( ( rule__Model__PackagesAssignment )* ) ;
    public final void ruleModel() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:66:2: ( ( ( rule__Model__PackagesAssignment )* ) )
            // InternalDslB.g:67:2: ( ( rule__Model__PackagesAssignment )* )
            {
            // InternalDslB.g:67:2: ( ( rule__Model__PackagesAssignment )* )
            // InternalDslB.g:68:3: ( rule__Model__PackagesAssignment )*
            {
             before(grammarAccess.getModelAccess().getPackagesAssignment()); 
            // InternalDslB.g:69:3: ( rule__Model__PackagesAssignment )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==12) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // InternalDslB.g:69:4: rule__Model__PackagesAssignment
            	    {
            	    pushFollow(FOLLOW_3);
            	    rule__Model__PackagesAssignment();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

             after(grammarAccess.getModelAccess().getPackagesAssignment()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleModel"


    // $ANTLR start "entryRuleQualifiedName"
    // InternalDslB.g:78:1: entryRuleQualifiedName : ruleQualifiedName EOF ;
    public final void entryRuleQualifiedName() throws RecognitionException {
        try {
            // InternalDslB.g:79:1: ( ruleQualifiedName EOF )
            // InternalDslB.g:80:1: ruleQualifiedName EOF
            {
             before(grammarAccess.getQualifiedNameRule()); 
            pushFollow(FOLLOW_1);
            ruleQualifiedName();

            state._fsp--;

             after(grammarAccess.getQualifiedNameRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleQualifiedName"


    // $ANTLR start "ruleQualifiedName"
    // InternalDslB.g:87:1: ruleQualifiedName : ( ( rule__QualifiedName__Group__0 ) ) ;
    public final void ruleQualifiedName() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:91:2: ( ( ( rule__QualifiedName__Group__0 ) ) )
            // InternalDslB.g:92:2: ( ( rule__QualifiedName__Group__0 ) )
            {
            // InternalDslB.g:92:2: ( ( rule__QualifiedName__Group__0 ) )
            // InternalDslB.g:93:3: ( rule__QualifiedName__Group__0 )
            {
             before(grammarAccess.getQualifiedNameAccess().getGroup()); 
            // InternalDslB.g:94:3: ( rule__QualifiedName__Group__0 )
            // InternalDslB.g:94:4: rule__QualifiedName__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getQualifiedNameAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleQualifiedName"


    // $ANTLR start "entryRulePkgDeclaration"
    // InternalDslB.g:103:1: entryRulePkgDeclaration : rulePkgDeclaration EOF ;
    public final void entryRulePkgDeclaration() throws RecognitionException {
        try {
            // InternalDslB.g:104:1: ( rulePkgDeclaration EOF )
            // InternalDslB.g:105:1: rulePkgDeclaration EOF
            {
             before(grammarAccess.getPkgDeclarationRule()); 
            pushFollow(FOLLOW_1);
            rulePkgDeclaration();

            state._fsp--;

             after(grammarAccess.getPkgDeclarationRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePkgDeclaration"


    // $ANTLR start "rulePkgDeclaration"
    // InternalDslB.g:112:1: rulePkgDeclaration : ( ( rule__PkgDeclaration__Group__0 ) ) ;
    public final void rulePkgDeclaration() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:116:2: ( ( ( rule__PkgDeclaration__Group__0 ) ) )
            // InternalDslB.g:117:2: ( ( rule__PkgDeclaration__Group__0 ) )
            {
            // InternalDslB.g:117:2: ( ( rule__PkgDeclaration__Group__0 ) )
            // InternalDslB.g:118:3: ( rule__PkgDeclaration__Group__0 )
            {
             before(grammarAccess.getPkgDeclarationAccess().getGroup()); 
            // InternalDslB.g:119:3: ( rule__PkgDeclaration__Group__0 )
            // InternalDslB.g:119:4: rule__PkgDeclaration__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__PkgDeclaration__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getPkgDeclarationAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePkgDeclaration"


    // $ANTLR start "entryRuleParts"
    // InternalDslB.g:128:1: entryRuleParts : ruleParts EOF ;
    public final void entryRuleParts() throws RecognitionException {
        try {
            // InternalDslB.g:129:1: ( ruleParts EOF )
            // InternalDslB.g:130:1: ruleParts EOF
            {
             before(grammarAccess.getPartsRule()); 
            pushFollow(FOLLOW_1);
            ruleParts();

            state._fsp--;

             after(grammarAccess.getPartsRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleParts"


    // $ANTLR start "ruleParts"
    // InternalDslB.g:137:1: ruleParts : ( ( rule__Parts__Alternatives ) ) ;
    public final void ruleParts() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:141:2: ( ( ( rule__Parts__Alternatives ) ) )
            // InternalDslB.g:142:2: ( ( rule__Parts__Alternatives ) )
            {
            // InternalDslB.g:142:2: ( ( rule__Parts__Alternatives ) )
            // InternalDslB.g:143:3: ( rule__Parts__Alternatives )
            {
             before(grammarAccess.getPartsAccess().getAlternatives()); 
            // InternalDslB.g:144:3: ( rule__Parts__Alternatives )
            // InternalDslB.g:144:4: rule__Parts__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__Parts__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getPartsAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleParts"


    // $ANTLR start "entryRuleImport"
    // InternalDslB.g:153:1: entryRuleImport : ruleImport EOF ;
    public final void entryRuleImport() throws RecognitionException {
        try {
            // InternalDslB.g:154:1: ( ruleImport EOF )
            // InternalDslB.g:155:1: ruleImport EOF
            {
             before(grammarAccess.getImportRule()); 
            pushFollow(FOLLOW_1);
            ruleImport();

            state._fsp--;

             after(grammarAccess.getImportRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleImport"


    // $ANTLR start "ruleImport"
    // InternalDslB.g:162:1: ruleImport : ( ( rule__Import__Group__0 ) ) ;
    public final void ruleImport() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:166:2: ( ( ( rule__Import__Group__0 ) ) )
            // InternalDslB.g:167:2: ( ( rule__Import__Group__0 ) )
            {
            // InternalDslB.g:167:2: ( ( rule__Import__Group__0 ) )
            // InternalDslB.g:168:3: ( rule__Import__Group__0 )
            {
             before(grammarAccess.getImportAccess().getGroup()); 
            // InternalDslB.g:169:3: ( rule__Import__Group__0 )
            // InternalDslB.g:169:4: rule__Import__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Import__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getImportAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleImport"


    // $ANTLR start "entryRuleQualifiedNameWithWildcard"
    // InternalDslB.g:178:1: entryRuleQualifiedNameWithWildcard : ruleQualifiedNameWithWildcard EOF ;
    public final void entryRuleQualifiedNameWithWildcard() throws RecognitionException {
        try {
            // InternalDslB.g:179:1: ( ruleQualifiedNameWithWildcard EOF )
            // InternalDslB.g:180:1: ruleQualifiedNameWithWildcard EOF
            {
             before(grammarAccess.getQualifiedNameWithWildcardRule()); 
            pushFollow(FOLLOW_1);
            ruleQualifiedNameWithWildcard();

            state._fsp--;

             after(grammarAccess.getQualifiedNameWithWildcardRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleQualifiedNameWithWildcard"


    // $ANTLR start "ruleQualifiedNameWithWildcard"
    // InternalDslB.g:187:1: ruleQualifiedNameWithWildcard : ( ( rule__QualifiedNameWithWildcard__Group__0 ) ) ;
    public final void ruleQualifiedNameWithWildcard() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:191:2: ( ( ( rule__QualifiedNameWithWildcard__Group__0 ) ) )
            // InternalDslB.g:192:2: ( ( rule__QualifiedNameWithWildcard__Group__0 ) )
            {
            // InternalDslB.g:192:2: ( ( rule__QualifiedNameWithWildcard__Group__0 ) )
            // InternalDslB.g:193:3: ( rule__QualifiedNameWithWildcard__Group__0 )
            {
             before(grammarAccess.getQualifiedNameWithWildcardAccess().getGroup()); 
            // InternalDslB.g:194:3: ( rule__QualifiedNameWithWildcard__Group__0 )
            // InternalDslB.g:194:4: rule__QualifiedNameWithWildcard__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedNameWithWildcard__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getQualifiedNameWithWildcardAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleQualifiedNameWithWildcard"


    // $ANTLR start "entryRuleClient"
    // InternalDslB.g:203:1: entryRuleClient : ruleClient EOF ;
    public final void entryRuleClient() throws RecognitionException {
        try {
            // InternalDslB.g:204:1: ( ruleClient EOF )
            // InternalDslB.g:205:1: ruleClient EOF
            {
             before(grammarAccess.getClientRule()); 
            pushFollow(FOLLOW_1);
            ruleClient();

            state._fsp--;

             after(grammarAccess.getClientRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleClient"


    // $ANTLR start "ruleClient"
    // InternalDslB.g:212:1: ruleClient : ( ( rule__Client__Group__0 ) ) ;
    public final void ruleClient() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:216:2: ( ( ( rule__Client__Group__0 ) ) )
            // InternalDslB.g:217:2: ( ( rule__Client__Group__0 ) )
            {
            // InternalDslB.g:217:2: ( ( rule__Client__Group__0 ) )
            // InternalDslB.g:218:3: ( rule__Client__Group__0 )
            {
             before(grammarAccess.getClientAccess().getGroup()); 
            // InternalDslB.g:219:3: ( rule__Client__Group__0 )
            // InternalDslB.g:219:4: rule__Client__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Client__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getClientAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleClient"


    // $ANTLR start "entryRuleHost"
    // InternalDslB.g:228:1: entryRuleHost : ruleHost EOF ;
    public final void entryRuleHost() throws RecognitionException {
        try {
            // InternalDslB.g:229:1: ( ruleHost EOF )
            // InternalDslB.g:230:1: ruleHost EOF
            {
             before(grammarAccess.getHostRule()); 
            pushFollow(FOLLOW_1);
            ruleHost();

            state._fsp--;

             after(grammarAccess.getHostRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleHost"


    // $ANTLR start "ruleHost"
    // InternalDslB.g:237:1: ruleHost : ( ( rule__Host__Group__0 ) ) ;
    public final void ruleHost() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:241:2: ( ( ( rule__Host__Group__0 ) ) )
            // InternalDslB.g:242:2: ( ( rule__Host__Group__0 ) )
            {
            // InternalDslB.g:242:2: ( ( rule__Host__Group__0 ) )
            // InternalDslB.g:243:3: ( rule__Host__Group__0 )
            {
             before(grammarAccess.getHostAccess().getGroup()); 
            // InternalDslB.g:244:3: ( rule__Host__Group__0 )
            // InternalDslB.g:244:4: rule__Host__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Host__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getHostAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleHost"


    // $ANTLR start "rule__Parts__Alternatives"
    // InternalDslB.g:252:1: rule__Parts__Alternatives : ( ( ruleImport ) | ( ruleClient ) | ( ruleHost ) );
    public final void rule__Parts__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:256:1: ( ( ruleImport ) | ( ruleClient ) | ( ruleHost ) )
            int alt2=3;
            switch ( input.LA(1) ) {
            case 15:
                {
                alt2=1;
                }
                break;
            case 17:
                {
                alt2=2;
                }
                break;
            case 18:
                {
                alt2=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // InternalDslB.g:257:2: ( ruleImport )
                    {
                    // InternalDslB.g:257:2: ( ruleImport )
                    // InternalDslB.g:258:3: ruleImport
                    {
                     before(grammarAccess.getPartsAccess().getImportParserRuleCall_0()); 
                    pushFollow(FOLLOW_2);
                    ruleImport();

                    state._fsp--;

                     after(grammarAccess.getPartsAccess().getImportParserRuleCall_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalDslB.g:263:2: ( ruleClient )
                    {
                    // InternalDslB.g:263:2: ( ruleClient )
                    // InternalDslB.g:264:3: ruleClient
                    {
                     before(grammarAccess.getPartsAccess().getClientParserRuleCall_1()); 
                    pushFollow(FOLLOW_2);
                    ruleClient();

                    state._fsp--;

                     after(grammarAccess.getPartsAccess().getClientParserRuleCall_1()); 

                    }


                    }
                    break;
                case 3 :
                    // InternalDslB.g:269:2: ( ruleHost )
                    {
                    // InternalDslB.g:269:2: ( ruleHost )
                    // InternalDslB.g:270:3: ruleHost
                    {
                     before(grammarAccess.getPartsAccess().getHostParserRuleCall_2()); 
                    pushFollow(FOLLOW_2);
                    ruleHost();

                    state._fsp--;

                     after(grammarAccess.getPartsAccess().getHostParserRuleCall_2()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Parts__Alternatives"


    // $ANTLR start "rule__QualifiedName__Group__0"
    // InternalDslB.g:279:1: rule__QualifiedName__Group__0 : rule__QualifiedName__Group__0__Impl rule__QualifiedName__Group__1 ;
    public final void rule__QualifiedName__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:283:1: ( rule__QualifiedName__Group__0__Impl rule__QualifiedName__Group__1 )
            // InternalDslB.g:284:2: rule__QualifiedName__Group__0__Impl rule__QualifiedName__Group__1
            {
            pushFollow(FOLLOW_4);
            rule__QualifiedName__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__0"


    // $ANTLR start "rule__QualifiedName__Group__0__Impl"
    // InternalDslB.g:291:1: rule__QualifiedName__Group__0__Impl : ( RULE_ID ) ;
    public final void rule__QualifiedName__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:295:1: ( ( RULE_ID ) )
            // InternalDslB.g:296:1: ( RULE_ID )
            {
            // InternalDslB.g:296:1: ( RULE_ID )
            // InternalDslB.g:297:2: RULE_ID
            {
             before(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__0__Impl"


    // $ANTLR start "rule__QualifiedName__Group__1"
    // InternalDslB.g:306:1: rule__QualifiedName__Group__1 : rule__QualifiedName__Group__1__Impl ;
    public final void rule__QualifiedName__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:310:1: ( rule__QualifiedName__Group__1__Impl )
            // InternalDslB.g:311:2: rule__QualifiedName__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__1"


    // $ANTLR start "rule__QualifiedName__Group__1__Impl"
    // InternalDslB.g:317:1: rule__QualifiedName__Group__1__Impl : ( ( rule__QualifiedName__Group_1__0 )* ) ;
    public final void rule__QualifiedName__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:321:1: ( ( ( rule__QualifiedName__Group_1__0 )* ) )
            // InternalDslB.g:322:1: ( ( rule__QualifiedName__Group_1__0 )* )
            {
            // InternalDslB.g:322:1: ( ( rule__QualifiedName__Group_1__0 )* )
            // InternalDslB.g:323:2: ( rule__QualifiedName__Group_1__0 )*
            {
             before(grammarAccess.getQualifiedNameAccess().getGroup_1()); 
            // InternalDslB.g:324:2: ( rule__QualifiedName__Group_1__0 )*
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( (LA3_0==11) ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // InternalDslB.g:324:3: rule__QualifiedName__Group_1__0
            	    {
            	    pushFollow(FOLLOW_5);
            	    rule__QualifiedName__Group_1__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop3;
                }
            } while (true);

             after(grammarAccess.getQualifiedNameAccess().getGroup_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__1__Impl"


    // $ANTLR start "rule__QualifiedName__Group_1__0"
    // InternalDslB.g:333:1: rule__QualifiedName__Group_1__0 : rule__QualifiedName__Group_1__0__Impl rule__QualifiedName__Group_1__1 ;
    public final void rule__QualifiedName__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:337:1: ( rule__QualifiedName__Group_1__0__Impl rule__QualifiedName__Group_1__1 )
            // InternalDslB.g:338:2: rule__QualifiedName__Group_1__0__Impl rule__QualifiedName__Group_1__1
            {
            pushFollow(FOLLOW_6);
            rule__QualifiedName__Group_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__0"


    // $ANTLR start "rule__QualifiedName__Group_1__0__Impl"
    // InternalDslB.g:345:1: rule__QualifiedName__Group_1__0__Impl : ( '.' ) ;
    public final void rule__QualifiedName__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:349:1: ( ( '.' ) )
            // InternalDslB.g:350:1: ( '.' )
            {
            // InternalDslB.g:350:1: ( '.' )
            // InternalDslB.g:351:2: '.'
            {
             before(grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0()); 
            match(input,11,FOLLOW_2); 
             after(grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__0__Impl"


    // $ANTLR start "rule__QualifiedName__Group_1__1"
    // InternalDslB.g:360:1: rule__QualifiedName__Group_1__1 : rule__QualifiedName__Group_1__1__Impl ;
    public final void rule__QualifiedName__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:364:1: ( rule__QualifiedName__Group_1__1__Impl )
            // InternalDslB.g:365:2: rule__QualifiedName__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group_1__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__1"


    // $ANTLR start "rule__QualifiedName__Group_1__1__Impl"
    // InternalDslB.g:371:1: rule__QualifiedName__Group_1__1__Impl : ( RULE_ID ) ;
    public final void rule__QualifiedName__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:375:1: ( ( RULE_ID ) )
            // InternalDslB.g:376:1: ( RULE_ID )
            {
            // InternalDslB.g:376:1: ( RULE_ID )
            // InternalDslB.g:377:2: RULE_ID
            {
             before(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_1_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__1__Impl"


    // $ANTLR start "rule__PkgDeclaration__Group__0"
    // InternalDslB.g:387:1: rule__PkgDeclaration__Group__0 : rule__PkgDeclaration__Group__0__Impl rule__PkgDeclaration__Group__1 ;
    public final void rule__PkgDeclaration__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:391:1: ( rule__PkgDeclaration__Group__0__Impl rule__PkgDeclaration__Group__1 )
            // InternalDslB.g:392:2: rule__PkgDeclaration__Group__0__Impl rule__PkgDeclaration__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__PkgDeclaration__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PkgDeclaration__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PkgDeclaration__Group__0"


    // $ANTLR start "rule__PkgDeclaration__Group__0__Impl"
    // InternalDslB.g:399:1: rule__PkgDeclaration__Group__0__Impl : ( 'package' ) ;
    public final void rule__PkgDeclaration__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:403:1: ( ( 'package' ) )
            // InternalDslB.g:404:1: ( 'package' )
            {
            // InternalDslB.g:404:1: ( 'package' )
            // InternalDslB.g:405:2: 'package'
            {
             before(grammarAccess.getPkgDeclarationAccess().getPackageKeyword_0()); 
            match(input,12,FOLLOW_2); 
             after(grammarAccess.getPkgDeclarationAccess().getPackageKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PkgDeclaration__Group__0__Impl"


    // $ANTLR start "rule__PkgDeclaration__Group__1"
    // InternalDslB.g:414:1: rule__PkgDeclaration__Group__1 : rule__PkgDeclaration__Group__1__Impl rule__PkgDeclaration__Group__2 ;
    public final void rule__PkgDeclaration__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:418:1: ( rule__PkgDeclaration__Group__1__Impl rule__PkgDeclaration__Group__2 )
            // InternalDslB.g:419:2: rule__PkgDeclaration__Group__1__Impl rule__PkgDeclaration__Group__2
            {
            pushFollow(FOLLOW_7);
            rule__PkgDeclaration__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PkgDeclaration__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PkgDeclaration__Group__1"


    // $ANTLR start "rule__PkgDeclaration__Group__1__Impl"
    // InternalDslB.g:426:1: rule__PkgDeclaration__Group__1__Impl : ( ( rule__PkgDeclaration__NameAssignment_1 ) ) ;
    public final void rule__PkgDeclaration__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:430:1: ( ( ( rule__PkgDeclaration__NameAssignment_1 ) ) )
            // InternalDslB.g:431:1: ( ( rule__PkgDeclaration__NameAssignment_1 ) )
            {
            // InternalDslB.g:431:1: ( ( rule__PkgDeclaration__NameAssignment_1 ) )
            // InternalDslB.g:432:2: ( rule__PkgDeclaration__NameAssignment_1 )
            {
             before(grammarAccess.getPkgDeclarationAccess().getNameAssignment_1()); 
            // InternalDslB.g:433:2: ( rule__PkgDeclaration__NameAssignment_1 )
            // InternalDslB.g:433:3: rule__PkgDeclaration__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__PkgDeclaration__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getPkgDeclarationAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PkgDeclaration__Group__1__Impl"


    // $ANTLR start "rule__PkgDeclaration__Group__2"
    // InternalDslB.g:441:1: rule__PkgDeclaration__Group__2 : rule__PkgDeclaration__Group__2__Impl rule__PkgDeclaration__Group__3 ;
    public final void rule__PkgDeclaration__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:445:1: ( rule__PkgDeclaration__Group__2__Impl rule__PkgDeclaration__Group__3 )
            // InternalDslB.g:446:2: rule__PkgDeclaration__Group__2__Impl rule__PkgDeclaration__Group__3
            {
            pushFollow(FOLLOW_8);
            rule__PkgDeclaration__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PkgDeclaration__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PkgDeclaration__Group__2"


    // $ANTLR start "rule__PkgDeclaration__Group__2__Impl"
    // InternalDslB.g:453:1: rule__PkgDeclaration__Group__2__Impl : ( '{' ) ;
    public final void rule__PkgDeclaration__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:457:1: ( ( '{' ) )
            // InternalDslB.g:458:1: ( '{' )
            {
            // InternalDslB.g:458:1: ( '{' )
            // InternalDslB.g:459:2: '{'
            {
             before(grammarAccess.getPkgDeclarationAccess().getLeftCurlyBracketKeyword_2()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getPkgDeclarationAccess().getLeftCurlyBracketKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PkgDeclaration__Group__2__Impl"


    // $ANTLR start "rule__PkgDeclaration__Group__3"
    // InternalDslB.g:468:1: rule__PkgDeclaration__Group__3 : rule__PkgDeclaration__Group__3__Impl rule__PkgDeclaration__Group__4 ;
    public final void rule__PkgDeclaration__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:472:1: ( rule__PkgDeclaration__Group__3__Impl rule__PkgDeclaration__Group__4 )
            // InternalDslB.g:473:2: rule__PkgDeclaration__Group__3__Impl rule__PkgDeclaration__Group__4
            {
            pushFollow(FOLLOW_8);
            rule__PkgDeclaration__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PkgDeclaration__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PkgDeclaration__Group__3"


    // $ANTLR start "rule__PkgDeclaration__Group__3__Impl"
    // InternalDslB.g:480:1: rule__PkgDeclaration__Group__3__Impl : ( ( rule__PkgDeclaration__ElementsAssignment_3 )* ) ;
    public final void rule__PkgDeclaration__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:484:1: ( ( ( rule__PkgDeclaration__ElementsAssignment_3 )* ) )
            // InternalDslB.g:485:1: ( ( rule__PkgDeclaration__ElementsAssignment_3 )* )
            {
            // InternalDslB.g:485:1: ( ( rule__PkgDeclaration__ElementsAssignment_3 )* )
            // InternalDslB.g:486:2: ( rule__PkgDeclaration__ElementsAssignment_3 )*
            {
             before(grammarAccess.getPkgDeclarationAccess().getElementsAssignment_3()); 
            // InternalDslB.g:487:2: ( rule__PkgDeclaration__ElementsAssignment_3 )*
            loop4:
            do {
                int alt4=2;
                int LA4_0 = input.LA(1);

                if ( (LA4_0==15||(LA4_0>=17 && LA4_0<=18)) ) {
                    alt4=1;
                }


                switch (alt4) {
            	case 1 :
            	    // InternalDslB.g:487:3: rule__PkgDeclaration__ElementsAssignment_3
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__PkgDeclaration__ElementsAssignment_3();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop4;
                }
            } while (true);

             after(grammarAccess.getPkgDeclarationAccess().getElementsAssignment_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PkgDeclaration__Group__3__Impl"


    // $ANTLR start "rule__PkgDeclaration__Group__4"
    // InternalDslB.g:495:1: rule__PkgDeclaration__Group__4 : rule__PkgDeclaration__Group__4__Impl ;
    public final void rule__PkgDeclaration__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:499:1: ( rule__PkgDeclaration__Group__4__Impl )
            // InternalDslB.g:500:2: rule__PkgDeclaration__Group__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__PkgDeclaration__Group__4__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PkgDeclaration__Group__4"


    // $ANTLR start "rule__PkgDeclaration__Group__4__Impl"
    // InternalDslB.g:506:1: rule__PkgDeclaration__Group__4__Impl : ( '}' ) ;
    public final void rule__PkgDeclaration__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:510:1: ( ( '}' ) )
            // InternalDslB.g:511:1: ( '}' )
            {
            // InternalDslB.g:511:1: ( '}' )
            // InternalDslB.g:512:2: '}'
            {
             before(grammarAccess.getPkgDeclarationAccess().getRightCurlyBracketKeyword_4()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getPkgDeclarationAccess().getRightCurlyBracketKeyword_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PkgDeclaration__Group__4__Impl"


    // $ANTLR start "rule__Import__Group__0"
    // InternalDslB.g:522:1: rule__Import__Group__0 : rule__Import__Group__0__Impl rule__Import__Group__1 ;
    public final void rule__Import__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:526:1: ( rule__Import__Group__0__Impl rule__Import__Group__1 )
            // InternalDslB.g:527:2: rule__Import__Group__0__Impl rule__Import__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__Import__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Import__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__0"


    // $ANTLR start "rule__Import__Group__0__Impl"
    // InternalDslB.g:534:1: rule__Import__Group__0__Impl : ( 'import' ) ;
    public final void rule__Import__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:538:1: ( ( 'import' ) )
            // InternalDslB.g:539:1: ( 'import' )
            {
            // InternalDslB.g:539:1: ( 'import' )
            // InternalDslB.g:540:2: 'import'
            {
             before(grammarAccess.getImportAccess().getImportKeyword_0()); 
            match(input,15,FOLLOW_2); 
             after(grammarAccess.getImportAccess().getImportKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__0__Impl"


    // $ANTLR start "rule__Import__Group__1"
    // InternalDslB.g:549:1: rule__Import__Group__1 : rule__Import__Group__1__Impl ;
    public final void rule__Import__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:553:1: ( rule__Import__Group__1__Impl )
            // InternalDslB.g:554:2: rule__Import__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Import__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__1"


    // $ANTLR start "rule__Import__Group__1__Impl"
    // InternalDslB.g:560:1: rule__Import__Group__1__Impl : ( ( rule__Import__ImportedNamespaceAssignment_1 ) ) ;
    public final void rule__Import__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:564:1: ( ( ( rule__Import__ImportedNamespaceAssignment_1 ) ) )
            // InternalDslB.g:565:1: ( ( rule__Import__ImportedNamespaceAssignment_1 ) )
            {
            // InternalDslB.g:565:1: ( ( rule__Import__ImportedNamespaceAssignment_1 ) )
            // InternalDslB.g:566:2: ( rule__Import__ImportedNamespaceAssignment_1 )
            {
             before(grammarAccess.getImportAccess().getImportedNamespaceAssignment_1()); 
            // InternalDslB.g:567:2: ( rule__Import__ImportedNamespaceAssignment_1 )
            // InternalDslB.g:567:3: rule__Import__ImportedNamespaceAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Import__ImportedNamespaceAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getImportAccess().getImportedNamespaceAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__1__Impl"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__0"
    // InternalDslB.g:576:1: rule__QualifiedNameWithWildcard__Group__0 : rule__QualifiedNameWithWildcard__Group__0__Impl rule__QualifiedNameWithWildcard__Group__1 ;
    public final void rule__QualifiedNameWithWildcard__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:580:1: ( rule__QualifiedNameWithWildcard__Group__0__Impl rule__QualifiedNameWithWildcard__Group__1 )
            // InternalDslB.g:581:2: rule__QualifiedNameWithWildcard__Group__0__Impl rule__QualifiedNameWithWildcard__Group__1
            {
            pushFollow(FOLLOW_10);
            rule__QualifiedNameWithWildcard__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__QualifiedNameWithWildcard__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__0"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__0__Impl"
    // InternalDslB.g:588:1: rule__QualifiedNameWithWildcard__Group__0__Impl : ( ruleQualifiedName ) ;
    public final void rule__QualifiedNameWithWildcard__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:592:1: ( ( ruleQualifiedName ) )
            // InternalDslB.g:593:1: ( ruleQualifiedName )
            {
            // InternalDslB.g:593:1: ( ruleQualifiedName )
            // InternalDslB.g:594:2: ruleQualifiedName
            {
             before(grammarAccess.getQualifiedNameWithWildcardAccess().getQualifiedNameParserRuleCall_0()); 
            pushFollow(FOLLOW_2);
            ruleQualifiedName();

            state._fsp--;

             after(grammarAccess.getQualifiedNameWithWildcardAccess().getQualifiedNameParserRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__0__Impl"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__1"
    // InternalDslB.g:603:1: rule__QualifiedNameWithWildcard__Group__1 : rule__QualifiedNameWithWildcard__Group__1__Impl ;
    public final void rule__QualifiedNameWithWildcard__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:607:1: ( rule__QualifiedNameWithWildcard__Group__1__Impl )
            // InternalDslB.g:608:2: rule__QualifiedNameWithWildcard__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedNameWithWildcard__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__1"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__1__Impl"
    // InternalDslB.g:614:1: rule__QualifiedNameWithWildcard__Group__1__Impl : ( ( '.*' )? ) ;
    public final void rule__QualifiedNameWithWildcard__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:618:1: ( ( ( '.*' )? ) )
            // InternalDslB.g:619:1: ( ( '.*' )? )
            {
            // InternalDslB.g:619:1: ( ( '.*' )? )
            // InternalDslB.g:620:2: ( '.*' )?
            {
             before(grammarAccess.getQualifiedNameWithWildcardAccess().getFullStopAsteriskKeyword_1()); 
            // InternalDslB.g:621:2: ( '.*' )?
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==16) ) {
                alt5=1;
            }
            switch (alt5) {
                case 1 :
                    // InternalDslB.g:621:3: '.*'
                    {
                    match(input,16,FOLLOW_2); 

                    }
                    break;

            }

             after(grammarAccess.getQualifiedNameWithWildcardAccess().getFullStopAsteriskKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__1__Impl"


    // $ANTLR start "rule__Client__Group__0"
    // InternalDslB.g:630:1: rule__Client__Group__0 : rule__Client__Group__0__Impl rule__Client__Group__1 ;
    public final void rule__Client__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:634:1: ( rule__Client__Group__0__Impl rule__Client__Group__1 )
            // InternalDslB.g:635:2: rule__Client__Group__0__Impl rule__Client__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__Client__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Client__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Client__Group__0"


    // $ANTLR start "rule__Client__Group__0__Impl"
    // InternalDslB.g:642:1: rule__Client__Group__0__Impl : ( 'client' ) ;
    public final void rule__Client__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:646:1: ( ( 'client' ) )
            // InternalDslB.g:647:1: ( 'client' )
            {
            // InternalDslB.g:647:1: ( 'client' )
            // InternalDslB.g:648:2: 'client'
            {
             before(grammarAccess.getClientAccess().getClientKeyword_0()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getClientAccess().getClientKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Client__Group__0__Impl"


    // $ANTLR start "rule__Client__Group__1"
    // InternalDslB.g:657:1: rule__Client__Group__1 : rule__Client__Group__1__Impl rule__Client__Group__2 ;
    public final void rule__Client__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:661:1: ( rule__Client__Group__1__Impl rule__Client__Group__2 )
            // InternalDslB.g:662:2: rule__Client__Group__1__Impl rule__Client__Group__2
            {
            pushFollow(FOLLOW_7);
            rule__Client__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Client__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Client__Group__1"


    // $ANTLR start "rule__Client__Group__1__Impl"
    // InternalDslB.g:669:1: rule__Client__Group__1__Impl : ( ( rule__Client__ServiceAssignment_1 ) ) ;
    public final void rule__Client__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:673:1: ( ( ( rule__Client__ServiceAssignment_1 ) ) )
            // InternalDslB.g:674:1: ( ( rule__Client__ServiceAssignment_1 ) )
            {
            // InternalDslB.g:674:1: ( ( rule__Client__ServiceAssignment_1 ) )
            // InternalDslB.g:675:2: ( rule__Client__ServiceAssignment_1 )
            {
             before(grammarAccess.getClientAccess().getServiceAssignment_1()); 
            // InternalDslB.g:676:2: ( rule__Client__ServiceAssignment_1 )
            // InternalDslB.g:676:3: rule__Client__ServiceAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Client__ServiceAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getClientAccess().getServiceAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Client__Group__1__Impl"


    // $ANTLR start "rule__Client__Group__2"
    // InternalDslB.g:684:1: rule__Client__Group__2 : rule__Client__Group__2__Impl rule__Client__Group__3 ;
    public final void rule__Client__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:688:1: ( rule__Client__Group__2__Impl rule__Client__Group__3 )
            // InternalDslB.g:689:2: rule__Client__Group__2__Impl rule__Client__Group__3
            {
            pushFollow(FOLLOW_6);
            rule__Client__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Client__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Client__Group__2"


    // $ANTLR start "rule__Client__Group__2__Impl"
    // InternalDslB.g:696:1: rule__Client__Group__2__Impl : ( '{' ) ;
    public final void rule__Client__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:700:1: ( ( '{' ) )
            // InternalDslB.g:701:1: ( '{' )
            {
            // InternalDslB.g:701:1: ( '{' )
            // InternalDslB.g:702:2: '{'
            {
             before(grammarAccess.getClientAccess().getLeftCurlyBracketKeyword_2()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getClientAccess().getLeftCurlyBracketKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Client__Group__2__Impl"


    // $ANTLR start "rule__Client__Group__3"
    // InternalDslB.g:711:1: rule__Client__Group__3 : rule__Client__Group__3__Impl rule__Client__Group__4 ;
    public final void rule__Client__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:715:1: ( rule__Client__Group__3__Impl rule__Client__Group__4 )
            // InternalDslB.g:716:2: rule__Client__Group__3__Impl rule__Client__Group__4
            {
            pushFollow(FOLLOW_11);
            rule__Client__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Client__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Client__Group__3"


    // $ANTLR start "rule__Client__Group__3__Impl"
    // InternalDslB.g:723:1: rule__Client__Group__3__Impl : ( ( ( rule__Client__ServiceMethodsAssignment_3 ) ) ( ( rule__Client__ServiceMethodsAssignment_3 )* ) ) ;
    public final void rule__Client__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:727:1: ( ( ( ( rule__Client__ServiceMethodsAssignment_3 ) ) ( ( rule__Client__ServiceMethodsAssignment_3 )* ) ) )
            // InternalDslB.g:728:1: ( ( ( rule__Client__ServiceMethodsAssignment_3 ) ) ( ( rule__Client__ServiceMethodsAssignment_3 )* ) )
            {
            // InternalDslB.g:728:1: ( ( ( rule__Client__ServiceMethodsAssignment_3 ) ) ( ( rule__Client__ServiceMethodsAssignment_3 )* ) )
            // InternalDslB.g:729:2: ( ( rule__Client__ServiceMethodsAssignment_3 ) ) ( ( rule__Client__ServiceMethodsAssignment_3 )* )
            {
            // InternalDslB.g:729:2: ( ( rule__Client__ServiceMethodsAssignment_3 ) )
            // InternalDslB.g:730:3: ( rule__Client__ServiceMethodsAssignment_3 )
            {
             before(grammarAccess.getClientAccess().getServiceMethodsAssignment_3()); 
            // InternalDslB.g:731:3: ( rule__Client__ServiceMethodsAssignment_3 )
            // InternalDslB.g:731:4: rule__Client__ServiceMethodsAssignment_3
            {
            pushFollow(FOLLOW_12);
            rule__Client__ServiceMethodsAssignment_3();

            state._fsp--;


            }

             after(grammarAccess.getClientAccess().getServiceMethodsAssignment_3()); 

            }

            // InternalDslB.g:734:2: ( ( rule__Client__ServiceMethodsAssignment_3 )* )
            // InternalDslB.g:735:3: ( rule__Client__ServiceMethodsAssignment_3 )*
            {
             before(grammarAccess.getClientAccess().getServiceMethodsAssignment_3()); 
            // InternalDslB.g:736:3: ( rule__Client__ServiceMethodsAssignment_3 )*
            loop6:
            do {
                int alt6=2;
                int LA6_0 = input.LA(1);

                if ( (LA6_0==RULE_ID) ) {
                    alt6=1;
                }


                switch (alt6) {
            	case 1 :
            	    // InternalDslB.g:736:4: rule__Client__ServiceMethodsAssignment_3
            	    {
            	    pushFollow(FOLLOW_12);
            	    rule__Client__ServiceMethodsAssignment_3();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop6;
                }
            } while (true);

             after(grammarAccess.getClientAccess().getServiceMethodsAssignment_3()); 

            }


            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Client__Group__3__Impl"


    // $ANTLR start "rule__Client__Group__4"
    // InternalDslB.g:745:1: rule__Client__Group__4 : rule__Client__Group__4__Impl ;
    public final void rule__Client__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:749:1: ( rule__Client__Group__4__Impl )
            // InternalDslB.g:750:2: rule__Client__Group__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Client__Group__4__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Client__Group__4"


    // $ANTLR start "rule__Client__Group__4__Impl"
    // InternalDslB.g:756:1: rule__Client__Group__4__Impl : ( '}' ) ;
    public final void rule__Client__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:760:1: ( ( '}' ) )
            // InternalDslB.g:761:1: ( '}' )
            {
            // InternalDslB.g:761:1: ( '}' )
            // InternalDslB.g:762:2: '}'
            {
             before(grammarAccess.getClientAccess().getRightCurlyBracketKeyword_4()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getClientAccess().getRightCurlyBracketKeyword_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Client__Group__4__Impl"


    // $ANTLR start "rule__Host__Group__0"
    // InternalDslB.g:772:1: rule__Host__Group__0 : rule__Host__Group__0__Impl rule__Host__Group__1 ;
    public final void rule__Host__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:776:1: ( rule__Host__Group__0__Impl rule__Host__Group__1 )
            // InternalDslB.g:777:2: rule__Host__Group__0__Impl rule__Host__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__Host__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Host__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Host__Group__0"


    // $ANTLR start "rule__Host__Group__0__Impl"
    // InternalDslB.g:784:1: rule__Host__Group__0__Impl : ( 'host' ) ;
    public final void rule__Host__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:788:1: ( ( 'host' ) )
            // InternalDslB.g:789:1: ( 'host' )
            {
            // InternalDslB.g:789:1: ( 'host' )
            // InternalDslB.g:790:2: 'host'
            {
             before(grammarAccess.getHostAccess().getHostKeyword_0()); 
            match(input,18,FOLLOW_2); 
             after(grammarAccess.getHostAccess().getHostKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Host__Group__0__Impl"


    // $ANTLR start "rule__Host__Group__1"
    // InternalDslB.g:799:1: rule__Host__Group__1 : rule__Host__Group__1__Impl rule__Host__Group__2 ;
    public final void rule__Host__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:803:1: ( rule__Host__Group__1__Impl rule__Host__Group__2 )
            // InternalDslB.g:804:2: rule__Host__Group__1__Impl rule__Host__Group__2
            {
            pushFollow(FOLLOW_7);
            rule__Host__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Host__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Host__Group__1"


    // $ANTLR start "rule__Host__Group__1__Impl"
    // InternalDslB.g:811:1: rule__Host__Group__1__Impl : ( ( rule__Host__ServiceAssignment_1 ) ) ;
    public final void rule__Host__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:815:1: ( ( ( rule__Host__ServiceAssignment_1 ) ) )
            // InternalDslB.g:816:1: ( ( rule__Host__ServiceAssignment_1 ) )
            {
            // InternalDslB.g:816:1: ( ( rule__Host__ServiceAssignment_1 ) )
            // InternalDslB.g:817:2: ( rule__Host__ServiceAssignment_1 )
            {
             before(grammarAccess.getHostAccess().getServiceAssignment_1()); 
            // InternalDslB.g:818:2: ( rule__Host__ServiceAssignment_1 )
            // InternalDslB.g:818:3: rule__Host__ServiceAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Host__ServiceAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getHostAccess().getServiceAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Host__Group__1__Impl"


    // $ANTLR start "rule__Host__Group__2"
    // InternalDslB.g:826:1: rule__Host__Group__2 : rule__Host__Group__2__Impl rule__Host__Group__3 ;
    public final void rule__Host__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:830:1: ( rule__Host__Group__2__Impl rule__Host__Group__3 )
            // InternalDslB.g:831:2: rule__Host__Group__2__Impl rule__Host__Group__3
            {
            pushFollow(FOLLOW_6);
            rule__Host__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Host__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Host__Group__2"


    // $ANTLR start "rule__Host__Group__2__Impl"
    // InternalDslB.g:838:1: rule__Host__Group__2__Impl : ( '{' ) ;
    public final void rule__Host__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:842:1: ( ( '{' ) )
            // InternalDslB.g:843:1: ( '{' )
            {
            // InternalDslB.g:843:1: ( '{' )
            // InternalDslB.g:844:2: '{'
            {
             before(grammarAccess.getHostAccess().getLeftCurlyBracketKeyword_2()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getHostAccess().getLeftCurlyBracketKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Host__Group__2__Impl"


    // $ANTLR start "rule__Host__Group__3"
    // InternalDslB.g:853:1: rule__Host__Group__3 : rule__Host__Group__3__Impl rule__Host__Group__4 ;
    public final void rule__Host__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:857:1: ( rule__Host__Group__3__Impl rule__Host__Group__4 )
            // InternalDslB.g:858:2: rule__Host__Group__3__Impl rule__Host__Group__4
            {
            pushFollow(FOLLOW_11);
            rule__Host__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Host__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Host__Group__3"


    // $ANTLR start "rule__Host__Group__3__Impl"
    // InternalDslB.g:865:1: rule__Host__Group__3__Impl : ( ( ( rule__Host__ServiceMethodsAssignment_3 ) ) ( ( rule__Host__ServiceMethodsAssignment_3 )* ) ) ;
    public final void rule__Host__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:869:1: ( ( ( ( rule__Host__ServiceMethodsAssignment_3 ) ) ( ( rule__Host__ServiceMethodsAssignment_3 )* ) ) )
            // InternalDslB.g:870:1: ( ( ( rule__Host__ServiceMethodsAssignment_3 ) ) ( ( rule__Host__ServiceMethodsAssignment_3 )* ) )
            {
            // InternalDslB.g:870:1: ( ( ( rule__Host__ServiceMethodsAssignment_3 ) ) ( ( rule__Host__ServiceMethodsAssignment_3 )* ) )
            // InternalDslB.g:871:2: ( ( rule__Host__ServiceMethodsAssignment_3 ) ) ( ( rule__Host__ServiceMethodsAssignment_3 )* )
            {
            // InternalDslB.g:871:2: ( ( rule__Host__ServiceMethodsAssignment_3 ) )
            // InternalDslB.g:872:3: ( rule__Host__ServiceMethodsAssignment_3 )
            {
             before(grammarAccess.getHostAccess().getServiceMethodsAssignment_3()); 
            // InternalDslB.g:873:3: ( rule__Host__ServiceMethodsAssignment_3 )
            // InternalDslB.g:873:4: rule__Host__ServiceMethodsAssignment_3
            {
            pushFollow(FOLLOW_12);
            rule__Host__ServiceMethodsAssignment_3();

            state._fsp--;


            }

             after(grammarAccess.getHostAccess().getServiceMethodsAssignment_3()); 

            }

            // InternalDslB.g:876:2: ( ( rule__Host__ServiceMethodsAssignment_3 )* )
            // InternalDslB.g:877:3: ( rule__Host__ServiceMethodsAssignment_3 )*
            {
             before(grammarAccess.getHostAccess().getServiceMethodsAssignment_3()); 
            // InternalDslB.g:878:3: ( rule__Host__ServiceMethodsAssignment_3 )*
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( (LA7_0==RULE_ID) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // InternalDslB.g:878:4: rule__Host__ServiceMethodsAssignment_3
            	    {
            	    pushFollow(FOLLOW_12);
            	    rule__Host__ServiceMethodsAssignment_3();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop7;
                }
            } while (true);

             after(grammarAccess.getHostAccess().getServiceMethodsAssignment_3()); 

            }


            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Host__Group__3__Impl"


    // $ANTLR start "rule__Host__Group__4"
    // InternalDslB.g:887:1: rule__Host__Group__4 : rule__Host__Group__4__Impl ;
    public final void rule__Host__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:891:1: ( rule__Host__Group__4__Impl )
            // InternalDslB.g:892:2: rule__Host__Group__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Host__Group__4__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Host__Group__4"


    // $ANTLR start "rule__Host__Group__4__Impl"
    // InternalDslB.g:898:1: rule__Host__Group__4__Impl : ( '}' ) ;
    public final void rule__Host__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:902:1: ( ( '}' ) )
            // InternalDslB.g:903:1: ( '}' )
            {
            // InternalDslB.g:903:1: ( '}' )
            // InternalDslB.g:904:2: '}'
            {
             before(grammarAccess.getHostAccess().getRightCurlyBracketKeyword_4()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getHostAccess().getRightCurlyBracketKeyword_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Host__Group__4__Impl"


    // $ANTLR start "rule__Model__PackagesAssignment"
    // InternalDslB.g:914:1: rule__Model__PackagesAssignment : ( rulePkgDeclaration ) ;
    public final void rule__Model__PackagesAssignment() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:918:1: ( ( rulePkgDeclaration ) )
            // InternalDslB.g:919:2: ( rulePkgDeclaration )
            {
            // InternalDslB.g:919:2: ( rulePkgDeclaration )
            // InternalDslB.g:920:3: rulePkgDeclaration
            {
             before(grammarAccess.getModelAccess().getPackagesPkgDeclarationParserRuleCall_0()); 
            pushFollow(FOLLOW_2);
            rulePkgDeclaration();

            state._fsp--;

             after(grammarAccess.getModelAccess().getPackagesPkgDeclarationParserRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__PackagesAssignment"


    // $ANTLR start "rule__PkgDeclaration__NameAssignment_1"
    // InternalDslB.g:929:1: rule__PkgDeclaration__NameAssignment_1 : ( ruleQualifiedName ) ;
    public final void rule__PkgDeclaration__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:933:1: ( ( ruleQualifiedName ) )
            // InternalDslB.g:934:2: ( ruleQualifiedName )
            {
            // InternalDslB.g:934:2: ( ruleQualifiedName )
            // InternalDslB.g:935:3: ruleQualifiedName
            {
             before(grammarAccess.getPkgDeclarationAccess().getNameQualifiedNameParserRuleCall_1_0()); 
            pushFollow(FOLLOW_2);
            ruleQualifiedName();

            state._fsp--;

             after(grammarAccess.getPkgDeclarationAccess().getNameQualifiedNameParserRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PkgDeclaration__NameAssignment_1"


    // $ANTLR start "rule__PkgDeclaration__ElementsAssignment_3"
    // InternalDslB.g:944:1: rule__PkgDeclaration__ElementsAssignment_3 : ( ruleParts ) ;
    public final void rule__PkgDeclaration__ElementsAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:948:1: ( ( ruleParts ) )
            // InternalDslB.g:949:2: ( ruleParts )
            {
            // InternalDslB.g:949:2: ( ruleParts )
            // InternalDslB.g:950:3: ruleParts
            {
             before(grammarAccess.getPkgDeclarationAccess().getElementsPartsParserRuleCall_3_0()); 
            pushFollow(FOLLOW_2);
            ruleParts();

            state._fsp--;

             after(grammarAccess.getPkgDeclarationAccess().getElementsPartsParserRuleCall_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PkgDeclaration__ElementsAssignment_3"


    // $ANTLR start "rule__Import__ImportedNamespaceAssignment_1"
    // InternalDslB.g:959:1: rule__Import__ImportedNamespaceAssignment_1 : ( ruleQualifiedNameWithWildcard ) ;
    public final void rule__Import__ImportedNamespaceAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:963:1: ( ( ruleQualifiedNameWithWildcard ) )
            // InternalDslB.g:964:2: ( ruleQualifiedNameWithWildcard )
            {
            // InternalDslB.g:964:2: ( ruleQualifiedNameWithWildcard )
            // InternalDslB.g:965:3: ruleQualifiedNameWithWildcard
            {
             before(grammarAccess.getImportAccess().getImportedNamespaceQualifiedNameWithWildcardParserRuleCall_1_0()); 
            pushFollow(FOLLOW_2);
            ruleQualifiedNameWithWildcard();

            state._fsp--;

             after(grammarAccess.getImportAccess().getImportedNamespaceQualifiedNameWithWildcardParserRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__ImportedNamespaceAssignment_1"


    // $ANTLR start "rule__Client__ServiceAssignment_1"
    // InternalDslB.g:974:1: rule__Client__ServiceAssignment_1 : ( ( RULE_ID ) ) ;
    public final void rule__Client__ServiceAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:978:1: ( ( ( RULE_ID ) ) )
            // InternalDslB.g:979:2: ( ( RULE_ID ) )
            {
            // InternalDslB.g:979:2: ( ( RULE_ID ) )
            // InternalDslB.g:980:3: ( RULE_ID )
            {
             before(grammarAccess.getClientAccess().getServiceServiceCrossReference_1_0()); 
            // InternalDslB.g:981:3: ( RULE_ID )
            // InternalDslB.g:982:4: RULE_ID
            {
             before(grammarAccess.getClientAccess().getServiceServiceIDTerminalRuleCall_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getClientAccess().getServiceServiceIDTerminalRuleCall_1_0_1()); 

            }

             after(grammarAccess.getClientAccess().getServiceServiceCrossReference_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Client__ServiceAssignment_1"


    // $ANTLR start "rule__Client__ServiceMethodsAssignment_3"
    // InternalDslB.g:993:1: rule__Client__ServiceMethodsAssignment_3 : ( ( RULE_ID ) ) ;
    public final void rule__Client__ServiceMethodsAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:997:1: ( ( ( RULE_ID ) ) )
            // InternalDslB.g:998:2: ( ( RULE_ID ) )
            {
            // InternalDslB.g:998:2: ( ( RULE_ID ) )
            // InternalDslB.g:999:3: ( RULE_ID )
            {
             before(grammarAccess.getClientAccess().getServiceMethodsServiceMethodCrossReference_3_0()); 
            // InternalDslB.g:1000:3: ( RULE_ID )
            // InternalDslB.g:1001:4: RULE_ID
            {
             before(grammarAccess.getClientAccess().getServiceMethodsServiceMethodIDTerminalRuleCall_3_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getClientAccess().getServiceMethodsServiceMethodIDTerminalRuleCall_3_0_1()); 

            }

             after(grammarAccess.getClientAccess().getServiceMethodsServiceMethodCrossReference_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Client__ServiceMethodsAssignment_3"


    // $ANTLR start "rule__Host__ServiceAssignment_1"
    // InternalDslB.g:1012:1: rule__Host__ServiceAssignment_1 : ( ( RULE_ID ) ) ;
    public final void rule__Host__ServiceAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:1016:1: ( ( ( RULE_ID ) ) )
            // InternalDslB.g:1017:2: ( ( RULE_ID ) )
            {
            // InternalDslB.g:1017:2: ( ( RULE_ID ) )
            // InternalDslB.g:1018:3: ( RULE_ID )
            {
             before(grammarAccess.getHostAccess().getServiceServiceCrossReference_1_0()); 
            // InternalDslB.g:1019:3: ( RULE_ID )
            // InternalDslB.g:1020:4: RULE_ID
            {
             before(grammarAccess.getHostAccess().getServiceServiceIDTerminalRuleCall_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getHostAccess().getServiceServiceIDTerminalRuleCall_1_0_1()); 

            }

             after(grammarAccess.getHostAccess().getServiceServiceCrossReference_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Host__ServiceAssignment_1"


    // $ANTLR start "rule__Host__ServiceMethodsAssignment_3"
    // InternalDslB.g:1031:1: rule__Host__ServiceMethodsAssignment_3 : ( ( RULE_ID ) ) ;
    public final void rule__Host__ServiceMethodsAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslB.g:1035:1: ( ( ( RULE_ID ) ) )
            // InternalDslB.g:1036:2: ( ( RULE_ID ) )
            {
            // InternalDslB.g:1036:2: ( ( RULE_ID ) )
            // InternalDslB.g:1037:3: ( RULE_ID )
            {
             before(grammarAccess.getHostAccess().getServiceMethodsServiceMethodCrossReference_3_0()); 
            // InternalDslB.g:1038:3: ( RULE_ID )
            // InternalDslB.g:1039:4: RULE_ID
            {
             before(grammarAccess.getHostAccess().getServiceMethodsServiceMethodIDTerminalRuleCall_3_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getHostAccess().getServiceMethodsServiceMethodIDTerminalRuleCall_3_0_1()); 

            }

             after(grammarAccess.getHostAccess().getServiceMethodsServiceMethodCrossReference_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Host__ServiceMethodsAssignment_3"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000001002L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000000802L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x000000000006C000L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000068002L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x0000000000000012L});

}