package org.xtext.example.mydsl.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.xtext.example.mydsl.services.DslAGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalDslAParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'PUT'", "'GET'", "'DEL'", "'POST'", "'.'", "'.*'", "'package'", "'{'", "'}'", "'import'", "'service'", "':'"
    };
    public static final int RULE_STRING=6;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__19=19;
    public static final int T__15=15;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int T__18=18;
    public static final int T__11=11;
    public static final int T__12=12;
    public static final int T__13=13;
    public static final int T__14=14;
    public static final int EOF=-1;
    public static final int RULE_ID=4;
    public static final int RULE_WS=9;
    public static final int RULE_ANY_OTHER=10;
    public static final int RULE_INT=5;
    public static final int T__22=22;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__20=20;
    public static final int T__21=21;

    // delegates
    // delegators


        public InternalDslAParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalDslAParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalDslAParser.tokenNames; }
    public String getGrammarFileName() { return "InternalDslA.g"; }


    	private DslAGrammarAccess grammarAccess;

    	public void setGrammarAccess(DslAGrammarAccess grammarAccess) {
    		this.grammarAccess = grammarAccess;
    	}

    	@Override
    	protected Grammar getGrammar() {
    		return grammarAccess.getGrammar();
    	}

    	@Override
    	protected String getValueForTokenName(String tokenName) {
    		return tokenName;
    	}



    // $ANTLR start "entryRuleModel"
    // InternalDslA.g:53:1: entryRuleModel : ruleModel EOF ;
    public final void entryRuleModel() throws RecognitionException {
        try {
            // InternalDslA.g:54:1: ( ruleModel EOF )
            // InternalDslA.g:55:1: ruleModel EOF
            {
             before(grammarAccess.getModelRule()); 
            pushFollow(FOLLOW_1);
            ruleModel();

            state._fsp--;

             after(grammarAccess.getModelRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleModel"


    // $ANTLR start "ruleModel"
    // InternalDslA.g:62:1: ruleModel : ( ( rule__Model__ElementsAssignment )* ) ;
    public final void ruleModel() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:66:2: ( ( ( rule__Model__ElementsAssignment )* ) )
            // InternalDslA.g:67:2: ( ( rule__Model__ElementsAssignment )* )
            {
            // InternalDslA.g:67:2: ( ( rule__Model__ElementsAssignment )* )
            // InternalDslA.g:68:3: ( rule__Model__ElementsAssignment )*
            {
             before(grammarAccess.getModelAccess().getElementsAssignment()); 
            // InternalDslA.g:69:3: ( rule__Model__ElementsAssignment )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==17) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // InternalDslA.g:69:4: rule__Model__ElementsAssignment
            	    {
            	    pushFollow(FOLLOW_3);
            	    rule__Model__ElementsAssignment();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

             after(grammarAccess.getModelAccess().getElementsAssignment()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleModel"


    // $ANTLR start "entryRuleQualifiedName"
    // InternalDslA.g:78:1: entryRuleQualifiedName : ruleQualifiedName EOF ;
    public final void entryRuleQualifiedName() throws RecognitionException {
        try {
            // InternalDslA.g:79:1: ( ruleQualifiedName EOF )
            // InternalDslA.g:80:1: ruleQualifiedName EOF
            {
             before(grammarAccess.getQualifiedNameRule()); 
            pushFollow(FOLLOW_1);
            ruleQualifiedName();

            state._fsp--;

             after(grammarAccess.getQualifiedNameRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleQualifiedName"


    // $ANTLR start "ruleQualifiedName"
    // InternalDslA.g:87:1: ruleQualifiedName : ( ( rule__QualifiedName__Group__0 ) ) ;
    public final void ruleQualifiedName() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:91:2: ( ( ( rule__QualifiedName__Group__0 ) ) )
            // InternalDslA.g:92:2: ( ( rule__QualifiedName__Group__0 ) )
            {
            // InternalDslA.g:92:2: ( ( rule__QualifiedName__Group__0 ) )
            // InternalDslA.g:93:3: ( rule__QualifiedName__Group__0 )
            {
             before(grammarAccess.getQualifiedNameAccess().getGroup()); 
            // InternalDslA.g:94:3: ( rule__QualifiedName__Group__0 )
            // InternalDslA.g:94:4: rule__QualifiedName__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getQualifiedNameAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleQualifiedName"


    // $ANTLR start "entryRuleQualifiedNameWithWildcard"
    // InternalDslA.g:103:1: entryRuleQualifiedNameWithWildcard : ruleQualifiedNameWithWildcard EOF ;
    public final void entryRuleQualifiedNameWithWildcard() throws RecognitionException {
        try {
            // InternalDslA.g:104:1: ( ruleQualifiedNameWithWildcard EOF )
            // InternalDslA.g:105:1: ruleQualifiedNameWithWildcard EOF
            {
             before(grammarAccess.getQualifiedNameWithWildcardRule()); 
            pushFollow(FOLLOW_1);
            ruleQualifiedNameWithWildcard();

            state._fsp--;

             after(grammarAccess.getQualifiedNameWithWildcardRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleQualifiedNameWithWildcard"


    // $ANTLR start "ruleQualifiedNameWithWildcard"
    // InternalDslA.g:112:1: ruleQualifiedNameWithWildcard : ( ( rule__QualifiedNameWithWildcard__Group__0 ) ) ;
    public final void ruleQualifiedNameWithWildcard() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:116:2: ( ( ( rule__QualifiedNameWithWildcard__Group__0 ) ) )
            // InternalDslA.g:117:2: ( ( rule__QualifiedNameWithWildcard__Group__0 ) )
            {
            // InternalDslA.g:117:2: ( ( rule__QualifiedNameWithWildcard__Group__0 ) )
            // InternalDslA.g:118:3: ( rule__QualifiedNameWithWildcard__Group__0 )
            {
             before(grammarAccess.getQualifiedNameWithWildcardAccess().getGroup()); 
            // InternalDslA.g:119:3: ( rule__QualifiedNameWithWildcard__Group__0 )
            // InternalDslA.g:119:4: rule__QualifiedNameWithWildcard__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedNameWithWildcard__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getQualifiedNameWithWildcardAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleQualifiedNameWithWildcard"


    // $ANTLR start "entryRulePackageDeclaration"
    // InternalDslA.g:128:1: entryRulePackageDeclaration : rulePackageDeclaration EOF ;
    public final void entryRulePackageDeclaration() throws RecognitionException {
        try {
            // InternalDslA.g:129:1: ( rulePackageDeclaration EOF )
            // InternalDslA.g:130:1: rulePackageDeclaration EOF
            {
             before(grammarAccess.getPackageDeclarationRule()); 
            pushFollow(FOLLOW_1);
            rulePackageDeclaration();

            state._fsp--;

             after(grammarAccess.getPackageDeclarationRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePackageDeclaration"


    // $ANTLR start "rulePackageDeclaration"
    // InternalDslA.g:137:1: rulePackageDeclaration : ( ( rule__PackageDeclaration__Group__0 ) ) ;
    public final void rulePackageDeclaration() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:141:2: ( ( ( rule__PackageDeclaration__Group__0 ) ) )
            // InternalDslA.g:142:2: ( ( rule__PackageDeclaration__Group__0 ) )
            {
            // InternalDslA.g:142:2: ( ( rule__PackageDeclaration__Group__0 ) )
            // InternalDslA.g:143:3: ( rule__PackageDeclaration__Group__0 )
            {
             before(grammarAccess.getPackageDeclarationAccess().getGroup()); 
            // InternalDslA.g:144:3: ( rule__PackageDeclaration__Group__0 )
            // InternalDslA.g:144:4: rule__PackageDeclaration__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__PackageDeclaration__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getPackageDeclarationAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePackageDeclaration"


    // $ANTLR start "entryRuleImport"
    // InternalDslA.g:153:1: entryRuleImport : ruleImport EOF ;
    public final void entryRuleImport() throws RecognitionException {
        try {
            // InternalDslA.g:154:1: ( ruleImport EOF )
            // InternalDslA.g:155:1: ruleImport EOF
            {
             before(grammarAccess.getImportRule()); 
            pushFollow(FOLLOW_1);
            ruleImport();

            state._fsp--;

             after(grammarAccess.getImportRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleImport"


    // $ANTLR start "ruleImport"
    // InternalDslA.g:162:1: ruleImport : ( ( rule__Import__Group__0 ) ) ;
    public final void ruleImport() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:166:2: ( ( ( rule__Import__Group__0 ) ) )
            // InternalDslA.g:167:2: ( ( rule__Import__Group__0 ) )
            {
            // InternalDslA.g:167:2: ( ( rule__Import__Group__0 ) )
            // InternalDslA.g:168:3: ( rule__Import__Group__0 )
            {
             before(grammarAccess.getImportAccess().getGroup()); 
            // InternalDslA.g:169:3: ( rule__Import__Group__0 )
            // InternalDslA.g:169:4: rule__Import__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Import__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getImportAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleImport"


    // $ANTLR start "entryRuleParts"
    // InternalDslA.g:178:1: entryRuleParts : ruleParts EOF ;
    public final void entryRuleParts() throws RecognitionException {
        try {
            // InternalDslA.g:179:1: ( ruleParts EOF )
            // InternalDslA.g:180:1: ruleParts EOF
            {
             before(grammarAccess.getPartsRule()); 
            pushFollow(FOLLOW_1);
            ruleParts();

            state._fsp--;

             after(grammarAccess.getPartsRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleParts"


    // $ANTLR start "ruleParts"
    // InternalDslA.g:187:1: ruleParts : ( ( rule__Parts__Alternatives ) ) ;
    public final void ruleParts() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:191:2: ( ( ( rule__Parts__Alternatives ) ) )
            // InternalDslA.g:192:2: ( ( rule__Parts__Alternatives ) )
            {
            // InternalDslA.g:192:2: ( ( rule__Parts__Alternatives ) )
            // InternalDslA.g:193:3: ( rule__Parts__Alternatives )
            {
             before(grammarAccess.getPartsAccess().getAlternatives()); 
            // InternalDslA.g:194:3: ( rule__Parts__Alternatives )
            // InternalDslA.g:194:4: rule__Parts__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__Parts__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getPartsAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleParts"


    // $ANTLR start "entryRuleService"
    // InternalDslA.g:203:1: entryRuleService : ruleService EOF ;
    public final void entryRuleService() throws RecognitionException {
        try {
            // InternalDslA.g:204:1: ( ruleService EOF )
            // InternalDslA.g:205:1: ruleService EOF
            {
             before(grammarAccess.getServiceRule()); 
            pushFollow(FOLLOW_1);
            ruleService();

            state._fsp--;

             after(grammarAccess.getServiceRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleService"


    // $ANTLR start "ruleService"
    // InternalDslA.g:212:1: ruleService : ( ( rule__Service__Group__0 ) ) ;
    public final void ruleService() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:216:2: ( ( ( rule__Service__Group__0 ) ) )
            // InternalDslA.g:217:2: ( ( rule__Service__Group__0 ) )
            {
            // InternalDslA.g:217:2: ( ( rule__Service__Group__0 ) )
            // InternalDslA.g:218:3: ( rule__Service__Group__0 )
            {
             before(grammarAccess.getServiceAccess().getGroup()); 
            // InternalDslA.g:219:3: ( rule__Service__Group__0 )
            // InternalDslA.g:219:4: rule__Service__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Service__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getServiceAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleService"


    // $ANTLR start "entryRuleServiceMethod"
    // InternalDslA.g:228:1: entryRuleServiceMethod : ruleServiceMethod EOF ;
    public final void entryRuleServiceMethod() throws RecognitionException {
        try {
            // InternalDslA.g:229:1: ( ruleServiceMethod EOF )
            // InternalDslA.g:230:1: ruleServiceMethod EOF
            {
             before(grammarAccess.getServiceMethodRule()); 
            pushFollow(FOLLOW_1);
            ruleServiceMethod();

            state._fsp--;

             after(grammarAccess.getServiceMethodRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleServiceMethod"


    // $ANTLR start "ruleServiceMethod"
    // InternalDslA.g:237:1: ruleServiceMethod : ( ( rule__ServiceMethod__Group__0 ) ) ;
    public final void ruleServiceMethod() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:241:2: ( ( ( rule__ServiceMethod__Group__0 ) ) )
            // InternalDslA.g:242:2: ( ( rule__ServiceMethod__Group__0 ) )
            {
            // InternalDslA.g:242:2: ( ( rule__ServiceMethod__Group__0 ) )
            // InternalDslA.g:243:3: ( rule__ServiceMethod__Group__0 )
            {
             before(grammarAccess.getServiceMethodAccess().getGroup()); 
            // InternalDslA.g:244:3: ( rule__ServiceMethod__Group__0 )
            // InternalDslA.g:244:4: rule__ServiceMethod__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__ServiceMethod__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getServiceMethodAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleServiceMethod"


    // $ANTLR start "entryRuleServiceMethodType"
    // InternalDslA.g:253:1: entryRuleServiceMethodType : ruleServiceMethodType EOF ;
    public final void entryRuleServiceMethodType() throws RecognitionException {
        try {
            // InternalDslA.g:254:1: ( ruleServiceMethodType EOF )
            // InternalDslA.g:255:1: ruleServiceMethodType EOF
            {
             before(grammarAccess.getServiceMethodTypeRule()); 
            pushFollow(FOLLOW_1);
            ruleServiceMethodType();

            state._fsp--;

             after(grammarAccess.getServiceMethodTypeRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleServiceMethodType"


    // $ANTLR start "ruleServiceMethodType"
    // InternalDslA.g:262:1: ruleServiceMethodType : ( ( rule__ServiceMethodType__Alternatives ) ) ;
    public final void ruleServiceMethodType() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:266:2: ( ( ( rule__ServiceMethodType__Alternatives ) ) )
            // InternalDslA.g:267:2: ( ( rule__ServiceMethodType__Alternatives ) )
            {
            // InternalDslA.g:267:2: ( ( rule__ServiceMethodType__Alternatives ) )
            // InternalDslA.g:268:3: ( rule__ServiceMethodType__Alternatives )
            {
             before(grammarAccess.getServiceMethodTypeAccess().getAlternatives()); 
            // InternalDslA.g:269:3: ( rule__ServiceMethodType__Alternatives )
            // InternalDslA.g:269:4: rule__ServiceMethodType__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__ServiceMethodType__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getServiceMethodTypeAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleServiceMethodType"


    // $ANTLR start "rule__Parts__Alternatives"
    // InternalDslA.g:277:1: rule__Parts__Alternatives : ( ( ruleImport ) | ( ruleService ) );
    public final void rule__Parts__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:281:1: ( ( ruleImport ) | ( ruleService ) )
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==20) ) {
                alt2=1;
            }
            else if ( (LA2_0==21) ) {
                alt2=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }
            switch (alt2) {
                case 1 :
                    // InternalDslA.g:282:2: ( ruleImport )
                    {
                    // InternalDslA.g:282:2: ( ruleImport )
                    // InternalDslA.g:283:3: ruleImport
                    {
                     before(grammarAccess.getPartsAccess().getImportParserRuleCall_0()); 
                    pushFollow(FOLLOW_2);
                    ruleImport();

                    state._fsp--;

                     after(grammarAccess.getPartsAccess().getImportParserRuleCall_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalDslA.g:288:2: ( ruleService )
                    {
                    // InternalDslA.g:288:2: ( ruleService )
                    // InternalDslA.g:289:3: ruleService
                    {
                     before(grammarAccess.getPartsAccess().getServiceParserRuleCall_1()); 
                    pushFollow(FOLLOW_2);
                    ruleService();

                    state._fsp--;

                     after(grammarAccess.getPartsAccess().getServiceParserRuleCall_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Parts__Alternatives"


    // $ANTLR start "rule__ServiceMethodType__Alternatives"
    // InternalDslA.g:298:1: rule__ServiceMethodType__Alternatives : ( ( 'PUT' ) | ( 'GET' ) | ( 'DEL' ) | ( 'POST' ) );
    public final void rule__ServiceMethodType__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:302:1: ( ( 'PUT' ) | ( 'GET' ) | ( 'DEL' ) | ( 'POST' ) )
            int alt3=4;
            switch ( input.LA(1) ) {
            case 11:
                {
                alt3=1;
                }
                break;
            case 12:
                {
                alt3=2;
                }
                break;
            case 13:
                {
                alt3=3;
                }
                break;
            case 14:
                {
                alt3=4;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 3, 0, input);

                throw nvae;
            }

            switch (alt3) {
                case 1 :
                    // InternalDslA.g:303:2: ( 'PUT' )
                    {
                    // InternalDslA.g:303:2: ( 'PUT' )
                    // InternalDslA.g:304:3: 'PUT'
                    {
                     before(grammarAccess.getServiceMethodTypeAccess().getPUTKeyword_0()); 
                    match(input,11,FOLLOW_2); 
                     after(grammarAccess.getServiceMethodTypeAccess().getPUTKeyword_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalDslA.g:309:2: ( 'GET' )
                    {
                    // InternalDslA.g:309:2: ( 'GET' )
                    // InternalDslA.g:310:3: 'GET'
                    {
                     before(grammarAccess.getServiceMethodTypeAccess().getGETKeyword_1()); 
                    match(input,12,FOLLOW_2); 
                     after(grammarAccess.getServiceMethodTypeAccess().getGETKeyword_1()); 

                    }


                    }
                    break;
                case 3 :
                    // InternalDslA.g:315:2: ( 'DEL' )
                    {
                    // InternalDslA.g:315:2: ( 'DEL' )
                    // InternalDslA.g:316:3: 'DEL'
                    {
                     before(grammarAccess.getServiceMethodTypeAccess().getDELKeyword_2()); 
                    match(input,13,FOLLOW_2); 
                     after(grammarAccess.getServiceMethodTypeAccess().getDELKeyword_2()); 

                    }


                    }
                    break;
                case 4 :
                    // InternalDslA.g:321:2: ( 'POST' )
                    {
                    // InternalDslA.g:321:2: ( 'POST' )
                    // InternalDslA.g:322:3: 'POST'
                    {
                     before(grammarAccess.getServiceMethodTypeAccess().getPOSTKeyword_3()); 
                    match(input,14,FOLLOW_2); 
                     after(grammarAccess.getServiceMethodTypeAccess().getPOSTKeyword_3()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ServiceMethodType__Alternatives"


    // $ANTLR start "rule__QualifiedName__Group__0"
    // InternalDslA.g:331:1: rule__QualifiedName__Group__0 : rule__QualifiedName__Group__0__Impl rule__QualifiedName__Group__1 ;
    public final void rule__QualifiedName__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:335:1: ( rule__QualifiedName__Group__0__Impl rule__QualifiedName__Group__1 )
            // InternalDslA.g:336:2: rule__QualifiedName__Group__0__Impl rule__QualifiedName__Group__1
            {
            pushFollow(FOLLOW_4);
            rule__QualifiedName__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__0"


    // $ANTLR start "rule__QualifiedName__Group__0__Impl"
    // InternalDslA.g:343:1: rule__QualifiedName__Group__0__Impl : ( RULE_ID ) ;
    public final void rule__QualifiedName__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:347:1: ( ( RULE_ID ) )
            // InternalDslA.g:348:1: ( RULE_ID )
            {
            // InternalDslA.g:348:1: ( RULE_ID )
            // InternalDslA.g:349:2: RULE_ID
            {
             before(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__0__Impl"


    // $ANTLR start "rule__QualifiedName__Group__1"
    // InternalDslA.g:358:1: rule__QualifiedName__Group__1 : rule__QualifiedName__Group__1__Impl ;
    public final void rule__QualifiedName__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:362:1: ( rule__QualifiedName__Group__1__Impl )
            // InternalDslA.g:363:2: rule__QualifiedName__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__1"


    // $ANTLR start "rule__QualifiedName__Group__1__Impl"
    // InternalDslA.g:369:1: rule__QualifiedName__Group__1__Impl : ( ( rule__QualifiedName__Group_1__0 )* ) ;
    public final void rule__QualifiedName__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:373:1: ( ( ( rule__QualifiedName__Group_1__0 )* ) )
            // InternalDslA.g:374:1: ( ( rule__QualifiedName__Group_1__0 )* )
            {
            // InternalDslA.g:374:1: ( ( rule__QualifiedName__Group_1__0 )* )
            // InternalDslA.g:375:2: ( rule__QualifiedName__Group_1__0 )*
            {
             before(grammarAccess.getQualifiedNameAccess().getGroup_1()); 
            // InternalDslA.g:376:2: ( rule__QualifiedName__Group_1__0 )*
            loop4:
            do {
                int alt4=2;
                int LA4_0 = input.LA(1);

                if ( (LA4_0==15) ) {
                    alt4=1;
                }


                switch (alt4) {
            	case 1 :
            	    // InternalDslA.g:376:3: rule__QualifiedName__Group_1__0
            	    {
            	    pushFollow(FOLLOW_5);
            	    rule__QualifiedName__Group_1__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop4;
                }
            } while (true);

             after(grammarAccess.getQualifiedNameAccess().getGroup_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__1__Impl"


    // $ANTLR start "rule__QualifiedName__Group_1__0"
    // InternalDslA.g:385:1: rule__QualifiedName__Group_1__0 : rule__QualifiedName__Group_1__0__Impl rule__QualifiedName__Group_1__1 ;
    public final void rule__QualifiedName__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:389:1: ( rule__QualifiedName__Group_1__0__Impl rule__QualifiedName__Group_1__1 )
            // InternalDslA.g:390:2: rule__QualifiedName__Group_1__0__Impl rule__QualifiedName__Group_1__1
            {
            pushFollow(FOLLOW_6);
            rule__QualifiedName__Group_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__0"


    // $ANTLR start "rule__QualifiedName__Group_1__0__Impl"
    // InternalDslA.g:397:1: rule__QualifiedName__Group_1__0__Impl : ( '.' ) ;
    public final void rule__QualifiedName__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:401:1: ( ( '.' ) )
            // InternalDslA.g:402:1: ( '.' )
            {
            // InternalDslA.g:402:1: ( '.' )
            // InternalDslA.g:403:2: '.'
            {
             before(grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0()); 
            match(input,15,FOLLOW_2); 
             after(grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__0__Impl"


    // $ANTLR start "rule__QualifiedName__Group_1__1"
    // InternalDslA.g:412:1: rule__QualifiedName__Group_1__1 : rule__QualifiedName__Group_1__1__Impl ;
    public final void rule__QualifiedName__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:416:1: ( rule__QualifiedName__Group_1__1__Impl )
            // InternalDslA.g:417:2: rule__QualifiedName__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group_1__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__1"


    // $ANTLR start "rule__QualifiedName__Group_1__1__Impl"
    // InternalDslA.g:423:1: rule__QualifiedName__Group_1__1__Impl : ( RULE_ID ) ;
    public final void rule__QualifiedName__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:427:1: ( ( RULE_ID ) )
            // InternalDslA.g:428:1: ( RULE_ID )
            {
            // InternalDslA.g:428:1: ( RULE_ID )
            // InternalDslA.g:429:2: RULE_ID
            {
             before(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_1_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__1__Impl"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__0"
    // InternalDslA.g:439:1: rule__QualifiedNameWithWildcard__Group__0 : rule__QualifiedNameWithWildcard__Group__0__Impl rule__QualifiedNameWithWildcard__Group__1 ;
    public final void rule__QualifiedNameWithWildcard__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:443:1: ( rule__QualifiedNameWithWildcard__Group__0__Impl rule__QualifiedNameWithWildcard__Group__1 )
            // InternalDslA.g:444:2: rule__QualifiedNameWithWildcard__Group__0__Impl rule__QualifiedNameWithWildcard__Group__1
            {
            pushFollow(FOLLOW_7);
            rule__QualifiedNameWithWildcard__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__QualifiedNameWithWildcard__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__0"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__0__Impl"
    // InternalDslA.g:451:1: rule__QualifiedNameWithWildcard__Group__0__Impl : ( ruleQualifiedName ) ;
    public final void rule__QualifiedNameWithWildcard__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:455:1: ( ( ruleQualifiedName ) )
            // InternalDslA.g:456:1: ( ruleQualifiedName )
            {
            // InternalDslA.g:456:1: ( ruleQualifiedName )
            // InternalDslA.g:457:2: ruleQualifiedName
            {
             before(grammarAccess.getQualifiedNameWithWildcardAccess().getQualifiedNameParserRuleCall_0()); 
            pushFollow(FOLLOW_2);
            ruleQualifiedName();

            state._fsp--;

             after(grammarAccess.getQualifiedNameWithWildcardAccess().getQualifiedNameParserRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__0__Impl"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__1"
    // InternalDslA.g:466:1: rule__QualifiedNameWithWildcard__Group__1 : rule__QualifiedNameWithWildcard__Group__1__Impl ;
    public final void rule__QualifiedNameWithWildcard__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:470:1: ( rule__QualifiedNameWithWildcard__Group__1__Impl )
            // InternalDslA.g:471:2: rule__QualifiedNameWithWildcard__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedNameWithWildcard__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__1"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__1__Impl"
    // InternalDslA.g:477:1: rule__QualifiedNameWithWildcard__Group__1__Impl : ( ( '.*' )? ) ;
    public final void rule__QualifiedNameWithWildcard__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:481:1: ( ( ( '.*' )? ) )
            // InternalDslA.g:482:1: ( ( '.*' )? )
            {
            // InternalDslA.g:482:1: ( ( '.*' )? )
            // InternalDslA.g:483:2: ( '.*' )?
            {
             before(grammarAccess.getQualifiedNameWithWildcardAccess().getFullStopAsteriskKeyword_1()); 
            // InternalDslA.g:484:2: ( '.*' )?
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==16) ) {
                alt5=1;
            }
            switch (alt5) {
                case 1 :
                    // InternalDslA.g:484:3: '.*'
                    {
                    match(input,16,FOLLOW_2); 

                    }
                    break;

            }

             after(grammarAccess.getQualifiedNameWithWildcardAccess().getFullStopAsteriskKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__1__Impl"


    // $ANTLR start "rule__PackageDeclaration__Group__0"
    // InternalDslA.g:493:1: rule__PackageDeclaration__Group__0 : rule__PackageDeclaration__Group__0__Impl rule__PackageDeclaration__Group__1 ;
    public final void rule__PackageDeclaration__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:497:1: ( rule__PackageDeclaration__Group__0__Impl rule__PackageDeclaration__Group__1 )
            // InternalDslA.g:498:2: rule__PackageDeclaration__Group__0__Impl rule__PackageDeclaration__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__PackageDeclaration__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PackageDeclaration__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PackageDeclaration__Group__0"


    // $ANTLR start "rule__PackageDeclaration__Group__0__Impl"
    // InternalDslA.g:505:1: rule__PackageDeclaration__Group__0__Impl : ( 'package' ) ;
    public final void rule__PackageDeclaration__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:509:1: ( ( 'package' ) )
            // InternalDslA.g:510:1: ( 'package' )
            {
            // InternalDslA.g:510:1: ( 'package' )
            // InternalDslA.g:511:2: 'package'
            {
             before(grammarAccess.getPackageDeclarationAccess().getPackageKeyword_0()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getPackageDeclarationAccess().getPackageKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PackageDeclaration__Group__0__Impl"


    // $ANTLR start "rule__PackageDeclaration__Group__1"
    // InternalDslA.g:520:1: rule__PackageDeclaration__Group__1 : rule__PackageDeclaration__Group__1__Impl rule__PackageDeclaration__Group__2 ;
    public final void rule__PackageDeclaration__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:524:1: ( rule__PackageDeclaration__Group__1__Impl rule__PackageDeclaration__Group__2 )
            // InternalDslA.g:525:2: rule__PackageDeclaration__Group__1__Impl rule__PackageDeclaration__Group__2
            {
            pushFollow(FOLLOW_8);
            rule__PackageDeclaration__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PackageDeclaration__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PackageDeclaration__Group__1"


    // $ANTLR start "rule__PackageDeclaration__Group__1__Impl"
    // InternalDslA.g:532:1: rule__PackageDeclaration__Group__1__Impl : ( ( rule__PackageDeclaration__NameAssignment_1 ) ) ;
    public final void rule__PackageDeclaration__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:536:1: ( ( ( rule__PackageDeclaration__NameAssignment_1 ) ) )
            // InternalDslA.g:537:1: ( ( rule__PackageDeclaration__NameAssignment_1 ) )
            {
            // InternalDslA.g:537:1: ( ( rule__PackageDeclaration__NameAssignment_1 ) )
            // InternalDslA.g:538:2: ( rule__PackageDeclaration__NameAssignment_1 )
            {
             before(grammarAccess.getPackageDeclarationAccess().getNameAssignment_1()); 
            // InternalDslA.g:539:2: ( rule__PackageDeclaration__NameAssignment_1 )
            // InternalDslA.g:539:3: rule__PackageDeclaration__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__PackageDeclaration__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getPackageDeclarationAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PackageDeclaration__Group__1__Impl"


    // $ANTLR start "rule__PackageDeclaration__Group__2"
    // InternalDslA.g:547:1: rule__PackageDeclaration__Group__2 : rule__PackageDeclaration__Group__2__Impl rule__PackageDeclaration__Group__3 ;
    public final void rule__PackageDeclaration__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:551:1: ( rule__PackageDeclaration__Group__2__Impl rule__PackageDeclaration__Group__3 )
            // InternalDslA.g:552:2: rule__PackageDeclaration__Group__2__Impl rule__PackageDeclaration__Group__3
            {
            pushFollow(FOLLOW_9);
            rule__PackageDeclaration__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PackageDeclaration__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PackageDeclaration__Group__2"


    // $ANTLR start "rule__PackageDeclaration__Group__2__Impl"
    // InternalDslA.g:559:1: rule__PackageDeclaration__Group__2__Impl : ( '{' ) ;
    public final void rule__PackageDeclaration__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:563:1: ( ( '{' ) )
            // InternalDslA.g:564:1: ( '{' )
            {
            // InternalDslA.g:564:1: ( '{' )
            // InternalDslA.g:565:2: '{'
            {
             before(grammarAccess.getPackageDeclarationAccess().getLeftCurlyBracketKeyword_2()); 
            match(input,18,FOLLOW_2); 
             after(grammarAccess.getPackageDeclarationAccess().getLeftCurlyBracketKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PackageDeclaration__Group__2__Impl"


    // $ANTLR start "rule__PackageDeclaration__Group__3"
    // InternalDslA.g:574:1: rule__PackageDeclaration__Group__3 : rule__PackageDeclaration__Group__3__Impl rule__PackageDeclaration__Group__4 ;
    public final void rule__PackageDeclaration__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:578:1: ( rule__PackageDeclaration__Group__3__Impl rule__PackageDeclaration__Group__4 )
            // InternalDslA.g:579:2: rule__PackageDeclaration__Group__3__Impl rule__PackageDeclaration__Group__4
            {
            pushFollow(FOLLOW_9);
            rule__PackageDeclaration__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PackageDeclaration__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PackageDeclaration__Group__3"


    // $ANTLR start "rule__PackageDeclaration__Group__3__Impl"
    // InternalDslA.g:586:1: rule__PackageDeclaration__Group__3__Impl : ( ( rule__PackageDeclaration__ElementsAssignment_3 )* ) ;
    public final void rule__PackageDeclaration__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:590:1: ( ( ( rule__PackageDeclaration__ElementsAssignment_3 )* ) )
            // InternalDslA.g:591:1: ( ( rule__PackageDeclaration__ElementsAssignment_3 )* )
            {
            // InternalDslA.g:591:1: ( ( rule__PackageDeclaration__ElementsAssignment_3 )* )
            // InternalDslA.g:592:2: ( rule__PackageDeclaration__ElementsAssignment_3 )*
            {
             before(grammarAccess.getPackageDeclarationAccess().getElementsAssignment_3()); 
            // InternalDslA.g:593:2: ( rule__PackageDeclaration__ElementsAssignment_3 )*
            loop6:
            do {
                int alt6=2;
                int LA6_0 = input.LA(1);

                if ( ((LA6_0>=20 && LA6_0<=21)) ) {
                    alt6=1;
                }


                switch (alt6) {
            	case 1 :
            	    // InternalDslA.g:593:3: rule__PackageDeclaration__ElementsAssignment_3
            	    {
            	    pushFollow(FOLLOW_10);
            	    rule__PackageDeclaration__ElementsAssignment_3();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop6;
                }
            } while (true);

             after(grammarAccess.getPackageDeclarationAccess().getElementsAssignment_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PackageDeclaration__Group__3__Impl"


    // $ANTLR start "rule__PackageDeclaration__Group__4"
    // InternalDslA.g:601:1: rule__PackageDeclaration__Group__4 : rule__PackageDeclaration__Group__4__Impl ;
    public final void rule__PackageDeclaration__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:605:1: ( rule__PackageDeclaration__Group__4__Impl )
            // InternalDslA.g:606:2: rule__PackageDeclaration__Group__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__PackageDeclaration__Group__4__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PackageDeclaration__Group__4"


    // $ANTLR start "rule__PackageDeclaration__Group__4__Impl"
    // InternalDslA.g:612:1: rule__PackageDeclaration__Group__4__Impl : ( '}' ) ;
    public final void rule__PackageDeclaration__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:616:1: ( ( '}' ) )
            // InternalDslA.g:617:1: ( '}' )
            {
            // InternalDslA.g:617:1: ( '}' )
            // InternalDslA.g:618:2: '}'
            {
             before(grammarAccess.getPackageDeclarationAccess().getRightCurlyBracketKeyword_4()); 
            match(input,19,FOLLOW_2); 
             after(grammarAccess.getPackageDeclarationAccess().getRightCurlyBracketKeyword_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PackageDeclaration__Group__4__Impl"


    // $ANTLR start "rule__Import__Group__0"
    // InternalDslA.g:628:1: rule__Import__Group__0 : rule__Import__Group__0__Impl rule__Import__Group__1 ;
    public final void rule__Import__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:632:1: ( rule__Import__Group__0__Impl rule__Import__Group__1 )
            // InternalDslA.g:633:2: rule__Import__Group__0__Impl rule__Import__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__Import__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Import__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__0"


    // $ANTLR start "rule__Import__Group__0__Impl"
    // InternalDslA.g:640:1: rule__Import__Group__0__Impl : ( 'import' ) ;
    public final void rule__Import__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:644:1: ( ( 'import' ) )
            // InternalDslA.g:645:1: ( 'import' )
            {
            // InternalDslA.g:645:1: ( 'import' )
            // InternalDslA.g:646:2: 'import'
            {
             before(grammarAccess.getImportAccess().getImportKeyword_0()); 
            match(input,20,FOLLOW_2); 
             after(grammarAccess.getImportAccess().getImportKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__0__Impl"


    // $ANTLR start "rule__Import__Group__1"
    // InternalDslA.g:655:1: rule__Import__Group__1 : rule__Import__Group__1__Impl ;
    public final void rule__Import__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:659:1: ( rule__Import__Group__1__Impl )
            // InternalDslA.g:660:2: rule__Import__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Import__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__1"


    // $ANTLR start "rule__Import__Group__1__Impl"
    // InternalDslA.g:666:1: rule__Import__Group__1__Impl : ( ( rule__Import__ImportedNamespaceAssignment_1 ) ) ;
    public final void rule__Import__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:670:1: ( ( ( rule__Import__ImportedNamespaceAssignment_1 ) ) )
            // InternalDslA.g:671:1: ( ( rule__Import__ImportedNamespaceAssignment_1 ) )
            {
            // InternalDslA.g:671:1: ( ( rule__Import__ImportedNamespaceAssignment_1 ) )
            // InternalDslA.g:672:2: ( rule__Import__ImportedNamespaceAssignment_1 )
            {
             before(grammarAccess.getImportAccess().getImportedNamespaceAssignment_1()); 
            // InternalDslA.g:673:2: ( rule__Import__ImportedNamespaceAssignment_1 )
            // InternalDslA.g:673:3: rule__Import__ImportedNamespaceAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Import__ImportedNamespaceAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getImportAccess().getImportedNamespaceAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__1__Impl"


    // $ANTLR start "rule__Service__Group__0"
    // InternalDslA.g:682:1: rule__Service__Group__0 : rule__Service__Group__0__Impl rule__Service__Group__1 ;
    public final void rule__Service__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:686:1: ( rule__Service__Group__0__Impl rule__Service__Group__1 )
            // InternalDslA.g:687:2: rule__Service__Group__0__Impl rule__Service__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__Service__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Service__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Service__Group__0"


    // $ANTLR start "rule__Service__Group__0__Impl"
    // InternalDslA.g:694:1: rule__Service__Group__0__Impl : ( 'service' ) ;
    public final void rule__Service__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:698:1: ( ( 'service' ) )
            // InternalDslA.g:699:1: ( 'service' )
            {
            // InternalDslA.g:699:1: ( 'service' )
            // InternalDslA.g:700:2: 'service'
            {
             before(grammarAccess.getServiceAccess().getServiceKeyword_0()); 
            match(input,21,FOLLOW_2); 
             after(grammarAccess.getServiceAccess().getServiceKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Service__Group__0__Impl"


    // $ANTLR start "rule__Service__Group__1"
    // InternalDslA.g:709:1: rule__Service__Group__1 : rule__Service__Group__1__Impl rule__Service__Group__2 ;
    public final void rule__Service__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:713:1: ( rule__Service__Group__1__Impl rule__Service__Group__2 )
            // InternalDslA.g:714:2: rule__Service__Group__1__Impl rule__Service__Group__2
            {
            pushFollow(FOLLOW_8);
            rule__Service__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Service__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Service__Group__1"


    // $ANTLR start "rule__Service__Group__1__Impl"
    // InternalDslA.g:721:1: rule__Service__Group__1__Impl : ( ( rule__Service__NameAssignment_1 ) ) ;
    public final void rule__Service__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:725:1: ( ( ( rule__Service__NameAssignment_1 ) ) )
            // InternalDslA.g:726:1: ( ( rule__Service__NameAssignment_1 ) )
            {
            // InternalDslA.g:726:1: ( ( rule__Service__NameAssignment_1 ) )
            // InternalDslA.g:727:2: ( rule__Service__NameAssignment_1 )
            {
             before(grammarAccess.getServiceAccess().getNameAssignment_1()); 
            // InternalDslA.g:728:2: ( rule__Service__NameAssignment_1 )
            // InternalDslA.g:728:3: rule__Service__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Service__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getServiceAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Service__Group__1__Impl"


    // $ANTLR start "rule__Service__Group__2"
    // InternalDslA.g:736:1: rule__Service__Group__2 : rule__Service__Group__2__Impl rule__Service__Group__3 ;
    public final void rule__Service__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:740:1: ( rule__Service__Group__2__Impl rule__Service__Group__3 )
            // InternalDslA.g:741:2: rule__Service__Group__2__Impl rule__Service__Group__3
            {
            pushFollow(FOLLOW_11);
            rule__Service__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Service__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Service__Group__2"


    // $ANTLR start "rule__Service__Group__2__Impl"
    // InternalDslA.g:748:1: rule__Service__Group__2__Impl : ( '{' ) ;
    public final void rule__Service__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:752:1: ( ( '{' ) )
            // InternalDslA.g:753:1: ( '{' )
            {
            // InternalDslA.g:753:1: ( '{' )
            // InternalDslA.g:754:2: '{'
            {
             before(grammarAccess.getServiceAccess().getLeftCurlyBracketKeyword_2()); 
            match(input,18,FOLLOW_2); 
             after(grammarAccess.getServiceAccess().getLeftCurlyBracketKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Service__Group__2__Impl"


    // $ANTLR start "rule__Service__Group__3"
    // InternalDslA.g:763:1: rule__Service__Group__3 : rule__Service__Group__3__Impl rule__Service__Group__4 ;
    public final void rule__Service__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:767:1: ( rule__Service__Group__3__Impl rule__Service__Group__4 )
            // InternalDslA.g:768:2: rule__Service__Group__3__Impl rule__Service__Group__4
            {
            pushFollow(FOLLOW_11);
            rule__Service__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Service__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Service__Group__3"


    // $ANTLR start "rule__Service__Group__3__Impl"
    // InternalDslA.g:775:1: rule__Service__Group__3__Impl : ( ( rule__Service__ServicesAssignment_3 )* ) ;
    public final void rule__Service__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:779:1: ( ( ( rule__Service__ServicesAssignment_3 )* ) )
            // InternalDslA.g:780:1: ( ( rule__Service__ServicesAssignment_3 )* )
            {
            // InternalDslA.g:780:1: ( ( rule__Service__ServicesAssignment_3 )* )
            // InternalDslA.g:781:2: ( rule__Service__ServicesAssignment_3 )*
            {
             before(grammarAccess.getServiceAccess().getServicesAssignment_3()); 
            // InternalDslA.g:782:2: ( rule__Service__ServicesAssignment_3 )*
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( (LA7_0==RULE_ID) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // InternalDslA.g:782:3: rule__Service__ServicesAssignment_3
            	    {
            	    pushFollow(FOLLOW_12);
            	    rule__Service__ServicesAssignment_3();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop7;
                }
            } while (true);

             after(grammarAccess.getServiceAccess().getServicesAssignment_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Service__Group__3__Impl"


    // $ANTLR start "rule__Service__Group__4"
    // InternalDslA.g:790:1: rule__Service__Group__4 : rule__Service__Group__4__Impl ;
    public final void rule__Service__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:794:1: ( rule__Service__Group__4__Impl )
            // InternalDslA.g:795:2: rule__Service__Group__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Service__Group__4__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Service__Group__4"


    // $ANTLR start "rule__Service__Group__4__Impl"
    // InternalDslA.g:801:1: rule__Service__Group__4__Impl : ( '}' ) ;
    public final void rule__Service__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:805:1: ( ( '}' ) )
            // InternalDslA.g:806:1: ( '}' )
            {
            // InternalDslA.g:806:1: ( '}' )
            // InternalDslA.g:807:2: '}'
            {
             before(grammarAccess.getServiceAccess().getRightCurlyBracketKeyword_4()); 
            match(input,19,FOLLOW_2); 
             after(grammarAccess.getServiceAccess().getRightCurlyBracketKeyword_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Service__Group__4__Impl"


    // $ANTLR start "rule__ServiceMethod__Group__0"
    // InternalDslA.g:817:1: rule__ServiceMethod__Group__0 : rule__ServiceMethod__Group__0__Impl rule__ServiceMethod__Group__1 ;
    public final void rule__ServiceMethod__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:821:1: ( rule__ServiceMethod__Group__0__Impl rule__ServiceMethod__Group__1 )
            // InternalDslA.g:822:2: rule__ServiceMethod__Group__0__Impl rule__ServiceMethod__Group__1
            {
            pushFollow(FOLLOW_13);
            rule__ServiceMethod__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__ServiceMethod__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ServiceMethod__Group__0"


    // $ANTLR start "rule__ServiceMethod__Group__0__Impl"
    // InternalDslA.g:829:1: rule__ServiceMethod__Group__0__Impl : ( ( rule__ServiceMethod__NameAssignment_0 ) ) ;
    public final void rule__ServiceMethod__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:833:1: ( ( ( rule__ServiceMethod__NameAssignment_0 ) ) )
            // InternalDslA.g:834:1: ( ( rule__ServiceMethod__NameAssignment_0 ) )
            {
            // InternalDslA.g:834:1: ( ( rule__ServiceMethod__NameAssignment_0 ) )
            // InternalDslA.g:835:2: ( rule__ServiceMethod__NameAssignment_0 )
            {
             before(grammarAccess.getServiceMethodAccess().getNameAssignment_0()); 
            // InternalDslA.g:836:2: ( rule__ServiceMethod__NameAssignment_0 )
            // InternalDslA.g:836:3: rule__ServiceMethod__NameAssignment_0
            {
            pushFollow(FOLLOW_2);
            rule__ServiceMethod__NameAssignment_0();

            state._fsp--;


            }

             after(grammarAccess.getServiceMethodAccess().getNameAssignment_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ServiceMethod__Group__0__Impl"


    // $ANTLR start "rule__ServiceMethod__Group__1"
    // InternalDslA.g:844:1: rule__ServiceMethod__Group__1 : rule__ServiceMethod__Group__1__Impl rule__ServiceMethod__Group__2 ;
    public final void rule__ServiceMethod__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:848:1: ( rule__ServiceMethod__Group__1__Impl rule__ServiceMethod__Group__2 )
            // InternalDslA.g:849:2: rule__ServiceMethod__Group__1__Impl rule__ServiceMethod__Group__2
            {
            pushFollow(FOLLOW_14);
            rule__ServiceMethod__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__ServiceMethod__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ServiceMethod__Group__1"


    // $ANTLR start "rule__ServiceMethod__Group__1__Impl"
    // InternalDslA.g:856:1: rule__ServiceMethod__Group__1__Impl : ( ':' ) ;
    public final void rule__ServiceMethod__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:860:1: ( ( ':' ) )
            // InternalDslA.g:861:1: ( ':' )
            {
            // InternalDslA.g:861:1: ( ':' )
            // InternalDslA.g:862:2: ':'
            {
             before(grammarAccess.getServiceMethodAccess().getColonKeyword_1()); 
            match(input,22,FOLLOW_2); 
             after(grammarAccess.getServiceMethodAccess().getColonKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ServiceMethod__Group__1__Impl"


    // $ANTLR start "rule__ServiceMethod__Group__2"
    // InternalDslA.g:871:1: rule__ServiceMethod__Group__2 : rule__ServiceMethod__Group__2__Impl ;
    public final void rule__ServiceMethod__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:875:1: ( rule__ServiceMethod__Group__2__Impl )
            // InternalDslA.g:876:2: rule__ServiceMethod__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__ServiceMethod__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ServiceMethod__Group__2"


    // $ANTLR start "rule__ServiceMethod__Group__2__Impl"
    // InternalDslA.g:882:1: rule__ServiceMethod__Group__2__Impl : ( ( rule__ServiceMethod__MethodTypeAssignment_2 ) ) ;
    public final void rule__ServiceMethod__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:886:1: ( ( ( rule__ServiceMethod__MethodTypeAssignment_2 ) ) )
            // InternalDslA.g:887:1: ( ( rule__ServiceMethod__MethodTypeAssignment_2 ) )
            {
            // InternalDslA.g:887:1: ( ( rule__ServiceMethod__MethodTypeAssignment_2 ) )
            // InternalDslA.g:888:2: ( rule__ServiceMethod__MethodTypeAssignment_2 )
            {
             before(grammarAccess.getServiceMethodAccess().getMethodTypeAssignment_2()); 
            // InternalDslA.g:889:2: ( rule__ServiceMethod__MethodTypeAssignment_2 )
            // InternalDslA.g:889:3: rule__ServiceMethod__MethodTypeAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__ServiceMethod__MethodTypeAssignment_2();

            state._fsp--;


            }

             after(grammarAccess.getServiceMethodAccess().getMethodTypeAssignment_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ServiceMethod__Group__2__Impl"


    // $ANTLR start "rule__Model__ElementsAssignment"
    // InternalDslA.g:898:1: rule__Model__ElementsAssignment : ( rulePackageDeclaration ) ;
    public final void rule__Model__ElementsAssignment() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:902:1: ( ( rulePackageDeclaration ) )
            // InternalDslA.g:903:2: ( rulePackageDeclaration )
            {
            // InternalDslA.g:903:2: ( rulePackageDeclaration )
            // InternalDslA.g:904:3: rulePackageDeclaration
            {
             before(grammarAccess.getModelAccess().getElementsPackageDeclarationParserRuleCall_0()); 
            pushFollow(FOLLOW_2);
            rulePackageDeclaration();

            state._fsp--;

             after(grammarAccess.getModelAccess().getElementsPackageDeclarationParserRuleCall_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Model__ElementsAssignment"


    // $ANTLR start "rule__PackageDeclaration__NameAssignment_1"
    // InternalDslA.g:913:1: rule__PackageDeclaration__NameAssignment_1 : ( ruleQualifiedName ) ;
    public final void rule__PackageDeclaration__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:917:1: ( ( ruleQualifiedName ) )
            // InternalDslA.g:918:2: ( ruleQualifiedName )
            {
            // InternalDslA.g:918:2: ( ruleQualifiedName )
            // InternalDslA.g:919:3: ruleQualifiedName
            {
             before(grammarAccess.getPackageDeclarationAccess().getNameQualifiedNameParserRuleCall_1_0()); 
            pushFollow(FOLLOW_2);
            ruleQualifiedName();

            state._fsp--;

             after(grammarAccess.getPackageDeclarationAccess().getNameQualifiedNameParserRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PackageDeclaration__NameAssignment_1"


    // $ANTLR start "rule__PackageDeclaration__ElementsAssignment_3"
    // InternalDslA.g:928:1: rule__PackageDeclaration__ElementsAssignment_3 : ( ruleParts ) ;
    public final void rule__PackageDeclaration__ElementsAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:932:1: ( ( ruleParts ) )
            // InternalDslA.g:933:2: ( ruleParts )
            {
            // InternalDslA.g:933:2: ( ruleParts )
            // InternalDslA.g:934:3: ruleParts
            {
             before(grammarAccess.getPackageDeclarationAccess().getElementsPartsParserRuleCall_3_0()); 
            pushFollow(FOLLOW_2);
            ruleParts();

            state._fsp--;

             after(grammarAccess.getPackageDeclarationAccess().getElementsPartsParserRuleCall_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PackageDeclaration__ElementsAssignment_3"


    // $ANTLR start "rule__Import__ImportedNamespaceAssignment_1"
    // InternalDslA.g:943:1: rule__Import__ImportedNamespaceAssignment_1 : ( ruleQualifiedNameWithWildcard ) ;
    public final void rule__Import__ImportedNamespaceAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:947:1: ( ( ruleQualifiedNameWithWildcard ) )
            // InternalDslA.g:948:2: ( ruleQualifiedNameWithWildcard )
            {
            // InternalDslA.g:948:2: ( ruleQualifiedNameWithWildcard )
            // InternalDslA.g:949:3: ruleQualifiedNameWithWildcard
            {
             before(grammarAccess.getImportAccess().getImportedNamespaceQualifiedNameWithWildcardParserRuleCall_1_0()); 
            pushFollow(FOLLOW_2);
            ruleQualifiedNameWithWildcard();

            state._fsp--;

             after(grammarAccess.getImportAccess().getImportedNamespaceQualifiedNameWithWildcardParserRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__ImportedNamespaceAssignment_1"


    // $ANTLR start "rule__Service__NameAssignment_1"
    // InternalDslA.g:958:1: rule__Service__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__Service__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:962:1: ( ( RULE_ID ) )
            // InternalDslA.g:963:2: ( RULE_ID )
            {
            // InternalDslA.g:963:2: ( RULE_ID )
            // InternalDslA.g:964:3: RULE_ID
            {
             before(grammarAccess.getServiceAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getServiceAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Service__NameAssignment_1"


    // $ANTLR start "rule__Service__ServicesAssignment_3"
    // InternalDslA.g:973:1: rule__Service__ServicesAssignment_3 : ( ruleServiceMethod ) ;
    public final void rule__Service__ServicesAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:977:1: ( ( ruleServiceMethod ) )
            // InternalDslA.g:978:2: ( ruleServiceMethod )
            {
            // InternalDslA.g:978:2: ( ruleServiceMethod )
            // InternalDslA.g:979:3: ruleServiceMethod
            {
             before(grammarAccess.getServiceAccess().getServicesServiceMethodParserRuleCall_3_0()); 
            pushFollow(FOLLOW_2);
            ruleServiceMethod();

            state._fsp--;

             after(grammarAccess.getServiceAccess().getServicesServiceMethodParserRuleCall_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Service__ServicesAssignment_3"


    // $ANTLR start "rule__ServiceMethod__NameAssignment_0"
    // InternalDslA.g:988:1: rule__ServiceMethod__NameAssignment_0 : ( RULE_ID ) ;
    public final void rule__ServiceMethod__NameAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:992:1: ( ( RULE_ID ) )
            // InternalDslA.g:993:2: ( RULE_ID )
            {
            // InternalDslA.g:993:2: ( RULE_ID )
            // InternalDslA.g:994:3: RULE_ID
            {
             before(grammarAccess.getServiceMethodAccess().getNameIDTerminalRuleCall_0_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getServiceMethodAccess().getNameIDTerminalRuleCall_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ServiceMethod__NameAssignment_0"


    // $ANTLR start "rule__ServiceMethod__MethodTypeAssignment_2"
    // InternalDslA.g:1003:1: rule__ServiceMethod__MethodTypeAssignment_2 : ( ruleServiceMethodType ) ;
    public final void rule__ServiceMethod__MethodTypeAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDslA.g:1007:1: ( ( ruleServiceMethodType ) )
            // InternalDslA.g:1008:2: ( ruleServiceMethodType )
            {
            // InternalDslA.g:1008:2: ( ruleServiceMethodType )
            // InternalDslA.g:1009:3: ruleServiceMethodType
            {
             before(grammarAccess.getServiceMethodAccess().getMethodTypeServiceMethodTypeParserRuleCall_2_0()); 
            pushFollow(FOLLOW_2);
            ruleServiceMethodType();

            state._fsp--;

             after(grammarAccess.getServiceMethodAccess().getMethodTypeServiceMethodTypeParserRuleCall_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ServiceMethod__MethodTypeAssignment_2"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000020002L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000008002L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000380000L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000300002L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000000000080010L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x0000000000000012L});
    public static final BitSet FOLLOW_13 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_14 = new BitSet(new long[]{0x0000000000007800L});

}